import * as i0 from '@angular/core';
import { NgModule, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, PLATFORM_ID, Inject, ViewChild, Directive, Injectable, EventEmitter, Output, HostListener, forwardRef, LOCALE_ID, Pipe, ContentChildren } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule, isPlatformBrowser, getLocaleDateFormat, FormatWidth, WeekDay, getLocaleDayNames, FormStyle, TranslationWidth, formatDate, getLocaleFirstDayOfWeek } from '@angular/common';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { RIGHT_ARROW, LEFT_ARROW, DOWN_ARROW, UP_ARROW } from '@angular/cdk/keycodes';
import { coerceNumberProperty } from '@angular/cdk/coercion';
import * as i1$1 from '@angular/cdk/overlay';
import { CdkOverlayOrigin, OverlayModule } from '@angular/cdk/overlay';
import { __classPrivateFieldSet, __classPrivateFieldGet } from 'tslib';
import { merge } from 'rxjs';
import { startWith, mergeMap, filter } from 'rxjs/operators';
import * as i2 from '@angular/cdk/a11y';
import { A11yModule } from '@angular/cdk/a11y';

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class SimpleCoreUIModule {
}
SimpleCoreUIModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: SimpleCoreUIModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SimpleCoreUIModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: SimpleCoreUIModule });
SimpleCoreUIModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: SimpleCoreUIModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: SimpleCoreUIModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [],
                    exports: []
                }]
        }] });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class ButtonDirective {
    constructor(renderer, element) {
        this.renderer = renderer;
        this.element = element;
        this.size = 'md';
        this.themeColor = 'primary';
    }
    ngOnInit() {
        this.renderer.addClass(this.element.nativeElement, "core-button");
        switch (this.size) {
            case "sm": // Small
                this.renderer.addClass(this.element.nativeElement, "core-button__size-sm");
                break;
            case "lg": // Large
                this.renderer.addClass(this.element.nativeElement, "core-button__size-lg");
                break;
            default: // (md) Medium
                this.renderer.addClass(this.element.nativeElement, "core-button__size-md");
                break;
        }
        switch (this.themeColor) {
            case "secondary":
                this.renderer.addClass(this.element.nativeElement, "core-button__background-secondary");
                break;
            case "transparent":
                this.renderer.addClass(this.element.nativeElement, "core-button__transparent");
                break;
            default: // Primary
                this.renderer.addClass(this.element.nativeElement, "core-button__background-primary");
                break;
        }
    }
}
ButtonDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ButtonDirective, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
ButtonDirective.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: ButtonDirective, selector: "button[coreButton]", inputs: { size: "size", themeColor: "themeColor" }, exportAs: ["coreButton"], ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: ["/**\n * @license\n * Copyright 2020 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n *//**\n* @license\n* Copyright 2021 SimpleCore All Rights Reserved.\n*\n* Use of this source code is governed private licensing for\n* internal SimpleCore projects\n*/.core-button{color:#fff;padding:10px 14px;border-radius:var(--border-radius-action);font-family:var(--core-font-primary);font-size:var(--core-size-body);font-weight:500;cursor:pointer;border:none;transition:all var(--core-animation-speed-fade)}.core-button:focus{outline:0}.core-button__background-primary:hover{background-color:var(--core-color-primary-shade)}.core-button__background-secondary:hover{background-color:var(--core-color-secondary-shade)}.core-button__background-primary:active{background-color:var(--core-color-primary-force)}.core-button__background-secondary:active{background-color:var(--core-color-secondary-force)}.core-button__transparent{color:var(--core-color-dark);background-color:transparent}.core-button__transparent:hover{background-color:var(--core-light-gray)}.core-button__transparent:active{background-color:var(--core-active-gray)}.core-button__size-sm{padding:8px 10px;font-size:var(--core-size-body)}.core-button__size-md{padding:11px 14px}.core-button__size-lg{padding:14px 18px}.core-button__background-primary{background-color:var(--core-color-primary)}.core-button__background-secondary{background-color:var(--core-color-secondary)}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ButtonDirective, decorators: [{
            type: Component,
            args: [{ selector: 'button[coreButton]', exportAs: 'coreButton', template: '<ng-content></ng-content>', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, styles: ["/**\n * @license\n * Copyright 2020 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n *//**\n* @license\n* Copyright 2021 SimpleCore All Rights Reserved.\n*\n* Use of this source code is governed private licensing for\n* internal SimpleCore projects\n*/.core-button{color:#fff;padding:10px 14px;border-radius:var(--border-radius-action);font-family:var(--core-font-primary);font-size:var(--core-size-body);font-weight:500;cursor:pointer;border:none;transition:all var(--core-animation-speed-fade)}.core-button:focus{outline:0}.core-button__background-primary:hover{background-color:var(--core-color-primary-shade)}.core-button__background-secondary:hover{background-color:var(--core-color-secondary-shade)}.core-button__background-primary:active{background-color:var(--core-color-primary-force)}.core-button__background-secondary:active{background-color:var(--core-color-secondary-force)}.core-button__transparent{color:var(--core-color-dark);background-color:transparent}.core-button__transparent:hover{background-color:var(--core-light-gray)}.core-button__transparent:active{background-color:var(--core-active-gray)}.core-button__size-sm{padding:8px 10px;font-size:var(--core-size-body)}.core-button__size-md{padding:11px 14px}.core-button__size-lg{padding:14px 18px}.core-button__background-primary{background-color:var(--core-color-primary)}.core-button__background-secondary{background-color:var(--core-color-secondary)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }]; }, propDecorators: { size: [{
                type: Input
            }], themeColor: [{
                type: Input
            }] } });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreButtonModule {
}
CoreButtonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreButtonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreButtonModule, declarations: [ButtonDirective], imports: [CommonModule], exports: [ButtonDirective] });
CoreButtonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreButtonModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ButtonDirective],
                    imports: [
                        CommonModule
                    ],
                    exports: [ButtonDirective]
                }]
        }] });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreInput {
    constructor(element, renderer) {
        this.element = element;
        this.renderer = renderer;
        this.appearance = "outline";
    }
    ngOnInit() {
        switch (this.appearance) {
            case 'outline':
                // this.element.nativeElement.classList.add("core-input__outline");
                this.renderer.addClass(this.element.nativeElement, "core-input__outline");
                break;
            case 'standard':
                // this.element.nativeElement.classList.add("core-input__standard");
                this.renderer.addClass(this.element.nativeElement, "core-input__standard");
                break;
        }
        this.overrideBackgroundColor();
    }
    overrideBackgroundColor() {
        if (this.colorOverride) {
            this.renderer.setStyle(this.element.nativeElement, "background-color", `#${this.colorOverride}`);
            this.renderer.setStyle(this.element.nativeElement.nextElementSibling, "background-color", `#${this.colorOverride}`);
        }
    }
}
CoreInput.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreInput, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CoreInput.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreInput, selector: "input[coreInput]", inputs: { appearance: "appearance", colorOverride: "colorOverride" }, exportAs: ["coreInput"], ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-input__outline{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color)}.core-input__outline:focus{outline:0}.core-input__outline:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-input__outline:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-input__outline:focus+.core-label{font-weight:500}.core-input__standard{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;border:none;background-color:var(--core-background-color)}.core-input__standard:focus{outline:0}.core-input__outline::placeholder{color:transparent}.core-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content}.core-input__outline:focus+.core-label,.core-input__outline:not(:placeholder-shown)+.core-label{transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}.core-input__outline:-webkit-autofill{-webkit-box-shadow:0 0 0px 1000px var(--core-background-color) inset}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreInput, decorators: [{
            type: Component,
            args: [{ selector: 'input[coreInput]', exportAs: 'coreInput', template: '<ng-content></ng-content>', host: {}, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-input__outline{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color)}.core-input__outline:focus{outline:0}.core-input__outline:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-input__outline:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-input__outline:focus+.core-label{font-weight:500}.core-input__standard{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;border:none;background-color:var(--core-background-color)}.core-input__standard:focus{outline:0}.core-input__outline::placeholder{color:transparent}.core-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content}.core-input__outline:focus+.core-label,.core-input__outline:not(:placeholder-shown)+.core-label{transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}.core-input__outline:-webkit-autofill{-webkit-box-shadow:0 0 0px 1000px var(--core-background-color) inset}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { appearance: [{
                type: Input
            }], colorOverride: [{
                type: Input
            }] } });
class CoreLabel {
    constructor() {
    }
    ngOnInit() {
    }
}
CoreLabel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreLabel, deps: [], target: i0.ɵɵFactoryTarget.Component });
CoreLabel.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreLabel, selector: "label[coreLabel]", host: { classAttribute: "core-label" }, exportAs: ["coreLabel"], ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-input__outline{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color)}.core-input__outline:focus{outline:0}.core-input__outline:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-input__outline:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-input__outline:focus+.core-label{font-weight:500}.core-input__standard{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;border:none;background-color:var(--core-background-color)}.core-input__standard:focus{outline:0}.core-input__outline::placeholder{color:transparent}.core-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content}.core-input__outline:focus+.core-label,.core-input__outline:not(:placeholder-shown)+.core-label{transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}.core-input__outline:-webkit-autofill{-webkit-box-shadow:0 0 0px 1000px var(--core-background-color) inset}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreLabel, decorators: [{
            type: Component,
            args: [{ selector: 'label[coreLabel]', exportAs: 'coreLabel', template: '<ng-content></ng-content>', host: {
                        'class': 'core-label',
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-input__outline{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color)}.core-input__outline:focus{outline:0}.core-input__outline:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-input__outline:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-input__outline:focus+.core-label{font-weight:500}.core-input__standard{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;border:none;background-color:var(--core-background-color)}.core-input__standard:focus{outline:0}.core-input__outline::placeholder{color:transparent}.core-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content}.core-input__outline:focus+.core-label,.core-input__outline:not(:placeholder-shown)+.core-label{transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}.core-input__outline:-webkit-autofill{-webkit-box-shadow:0 0 0px 1000px var(--core-background-color) inset}\n"] }]
        }], ctorParameters: function () { return []; } });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreInputModule {
}
CoreInputModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreInputModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreInputModule, declarations: [CoreInput, CoreLabel], imports: [CommonModule], exports: [CoreInput, CoreLabel] });
CoreInputModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreInputModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreInput, CoreLabel],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreInput, CoreLabel]
                }]
        }] });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreSelect {
    constructor(renderer, element, platformId) {
        this.renderer = renderer;
        this.element = element;
        this.platformId = platformId;
        this.corePlaceholderText = "Select options";
        this.mutationObserver = new MutationObserver(() => {
            this.applyLabelFloat();
        });
    }
    ngOnInit() {
        this.listenToFloatLabel(); // May be unnecessary but further testing is needed.
        this.overrideBackgroundColor();
        // Only run this if on browser
        if (isPlatformBrowser(this.platformId)) {
            // Create a mutation observer to check for more changes than value changes
            // The default HTML form reset event does not trigger the change event, but does trigger a mutation
            this.mutationObserver.observe(this.element.nativeElement, { attributes: true });
        }
    }
    ngOnDestroy() {
        if (isPlatformBrowser(this.platformId)) {
            // Disconnect from observer on destroy
            this.mutationObserver.disconnect();
        }
    }
    /* Add event listener to for select change to determine if float is needed */
    /* Candidate for deprecation */
    listenToFloatLabel() {
        this.element.nativeElement.addEventListener("change", () => {
            this.applyLabelFloat();
        });
    }
    /* Check if the label should be floating depending on the placeholder element
    *  and change classes if necessary */
    applyLabelFloat() {
        const floatingLabelElement = this.element.nativeElement.nextElementSibling;
        if (!floatingLabelElement) {
            return;
        }
        const placeholderOptionElement = this.element.nativeElement;
        const placeholderSelected = placeholderOptionElement.selectedIndex <= 0;
        // HTML form reset event sets index = -1
        // Placeholder is at index = 0
        if (!placeholderSelected) {
            this.renderer.addClass(floatingLabelElement, "core-select-label__floating");
        }
        else {
            this.renderer.removeClass(floatingLabelElement, "core-select-label__floating");
        }
    }
    /* Sets input background color  */
    overrideBackgroundColor() {
        if (this.colorOverride) {
            this.renderer.setStyle(this.element.nativeElement, "background-color", `#${this.colorOverride}`);
            this.renderer.setStyle(this.element.nativeElement.nextElementSibling, "background-color", `#${this.colorOverride}`);
        }
    }
}
CoreSelect.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelect, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Component });
CoreSelect.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreSelect, selector: "select[coreSelect]", inputs: { corePlaceholderText: "corePlaceholderText", colorOverride: "colorOverride" }, host: { classAttribute: "core-select" }, exportAs: ["coreSelect"], ngImport: i0, template: '<div class="core-select-arrow"><svg viewBox="0 0 24 24" role="presentation" class="chakra-select__icon" focusable="false" aria-hidden="true" style="width: 1em; height: 1em; color: currentcolor;"><path fill="currentColor" d="M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z"></path></svg></div><option class="core-select__placeholder-option" value="" disabled selected="selected">{{corePlaceholderText}}</option><ng-content></ng-content>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-select{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color);-webkit-appearance:none}.core-select:focus{outline:0}.core-select:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-select:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-select:focus+.core-select-label{font-weight:500}.core-select:after{content:\"<>\";font:17px Consolas,monospace;color:#333;transform:rotate(90deg);right:11px;top:18px;padding:0 0 2px;border-bottom:1px solid #999;position:absolute;pointer-events:none}.core-select-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content;min-width:90px}.core-select-label__floating{width:max-content;transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelect, decorators: [{
            type: Component,
            args: [{ selector: 'select[coreSelect]', exportAs: 'coreSelect', template: '<div class="core-select-arrow"><svg viewBox="0 0 24 24" role="presentation" class="chakra-select__icon" focusable="false" aria-hidden="true" style="width: 1em; height: 1em; color: currentcolor;"><path fill="currentColor" d="M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z"></path></svg></div><option class="core-select__placeholder-option" value="" disabled selected="selected">{{corePlaceholderText}}</option><ng-content></ng-content>', host: {
                        'class': 'core-select',
                    }, encapsulation: ViewEncapsulation.None, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-select{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color);-webkit-appearance:none}.core-select:focus{outline:0}.core-select:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-select:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-select:focus+.core-select-label{font-weight:500}.core-select:after{content:\"<>\";font:17px Consolas,monospace;color:#333;transform:rotate(90deg);right:11px;top:18px;padding:0 0 2px;border-bottom:1px solid #999;position:absolute;pointer-events:none}.core-select-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content;min-width:90px}.core-select-label__floating{width:max-content;transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }];
    }, propDecorators: { corePlaceholderText: [{
                type: Input
            }], colorOverride: [{
                type: Input
            }] } });
class CoreSelectLabel {
    constructor() {
    }
    ngOnInit() {
    }
}
CoreSelectLabel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectLabel, deps: [], target: i0.ɵɵFactoryTarget.Component });
CoreSelectLabel.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreSelectLabel, selector: "label[coreSelectLabel]", host: { classAttribute: "core-select-label" }, exportAs: ["coreSelectLabel"], ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-select{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color);-webkit-appearance:none}.core-select:focus{outline:0}.core-select:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-select:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-select:focus+.core-select-label{font-weight:500}.core-select:after{content:\"<>\";font:17px Consolas,monospace;color:#333;transform:rotate(90deg);right:11px;top:18px;padding:0 0 2px;border-bottom:1px solid #999;position:absolute;pointer-events:none}.core-select-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content;min-width:90px}.core-select-label__floating{width:max-content;transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectLabel, decorators: [{
            type: Component,
            args: [{ selector: 'label[coreSelectLabel]', exportAs: 'coreSelectLabel', template: '<ng-content></ng-content>', host: {
                        'class': 'core-select-label',
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-select{font-family:var(--core-font-primary);font-size:var(--core-size-body);padding:14px 15px;height:54px;border-radius:var(--border-radius-action);width:100%;transition:margin-left .1s ease-in-out,border .1s ease-in-out;box-sizing:border-box;border:1px solid var(--core-active-gray);background-color:var(--core-background-color);-webkit-appearance:none}.core-select:focus{outline:0}.core-select:hover{margin-left:-1px;border:2px solid var(--core-active-gray)}.core-select:focus{margin-left:-1px;border:2px solid var(--core-color-dark)}.core-select:focus+.core-select-label{font-weight:500}.core-select:after{content:\"<>\";font:17px Consolas,monospace;color:#333;transform:rotate(90deg);right:11px;top:18px;padding:0 0 2px;border-bottom:1px solid #999;position:absolute;pointer-events:none}.core-select-label{display:block;pointer-events:none;transition:transform .18s ease-in-out;font-family:var(--core-font-primary);padding:0 12px;box-sizing:content-box;background-color:var(--core-background-color);transform-origin:bottom left;position:absolute;margin-left:10px;margin-top:-37px;width:max-content;min-width:90px}.core-select-label__floating{width:max-content;transform:scale(.8) translateY(-35px);white-space:nowrap;text-overflow:ellipsis}\n"] }]
        }], ctorParameters: function () { return []; } });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreSelectModule {
}
CoreSelectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreSelectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectModule, declarations: [CoreSelect, CoreSelectLabel], imports: [CommonModule], exports: [CoreSelect, CoreSelectLabel] });
CoreSelectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreSelect, CoreSelectLabel],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreSelect, CoreSelectLabel]
                }]
        }] });

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreCard {
    constructor(renderer) {
        this.renderer = renderer;
        this.paddingSize = "extra-large";
        this.neumorphic = true;
        this.overridePadding = "";
        this.topAndBottomShadow = true;
        this.neumorphicShadowIsSet = false;
    }
    ngAfterViewInit() {
        if (this.neumorphic) {
            this.setNeumorphicShadow();
        }
        else {
            this.renderer.addClass(this.cardEl.nativeElement, 'core-card__outline');
        }
        if (this.overridePadding != "") {
            this.renderer.setStyle(this.cardEl.nativeElement, 'padding', this.overridePadding);
        }
        this.renderer.addClass(this.cardEl.nativeElement, 'core-card__padding__' + this.paddingSize);
    }
    // Find calculated width of the object to determine how to place the box shadow
    ngAfterViewChecked() {
        if (!this.neumorphic) {
            return;
        }
        if (this.neumorphicShadowIsSet) {
            return;
        }
        this.setNeumorphicShadow();
    }
    setNeumorphicShadow() {
        const offset = Math.min(this.cardEl.nativeElement.offsetHeight / 7.5, 20);
        if (offset !== 0) {
            this.neumorphicShadowIsSet = true;
        }
        else {
            return;
        }
        const blurOffset = offset * 1.5;
        this.renderer.setStyle(this.cardEl.nativeElement, 'box-shadow', this.buildBoxShadowString(this.topAndBottomShadow, offset, blurOffset));
    }
    buildBoxShadowString(topAndBottomShadow, offset, blurOffset) {
        let boxShadow = `0px ${offset}px ${blurOffset}px rgba(0,0,0,0.12)`;
        if (topAndBottomShadow) {
            boxShadow += `,
              -0px -${offset}px ${blurOffset}px rgba(255,255,255,0.85)`;
        }
        return boxShadow;
    }
}
CoreCard.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCard, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CoreCard.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreCard, selector: "core-card", inputs: { paddingSize: "paddingSize", neumorphic: "neumorphic", overridePadding: "overridePadding", topAndBottomShadow: "topAndBottomShadow" }, viewQueries: [{ propertyName: "cardEl", first: true, predicate: ["cardEl"], descendants: true }], exportAs: ["coreCard"], ngImport: i0, template: '<div #cardEl class="core-card"><ng-content></ng-content></div>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-card{border-radius:var(--border-radius-rounded-corner);background-color:var(--core-color-light)}.core-card__padding__extra-large{padding:var(--core-stack-margin-extra-large)}.core-card__padding__large{padding:var(--core-stack-margin-large)}.core-card__padding__medium{padding:var(--core-stack-margin-medium)}.core-card__padding__small{padding:var(--core-stack-margin-small)}.core-card__outline{border:1px solid var(--core-color-active)}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCard, decorators: [{
            type: Component,
            args: [{ selector: 'core-card', exportAs: 'coreCard', template: '<div #cardEl class="core-card"><ng-content></ng-content></div>', styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-card{border-radius:var(--border-radius-rounded-corner);background-color:var(--core-color-light)}.core-card__padding__extra-large{padding:var(--core-stack-margin-extra-large)}.core-card__padding__large{padding:var(--core-stack-margin-large)}.core-card__padding__medium{padding:var(--core-stack-margin-medium)}.core-card__padding__small{padding:var(--core-stack-margin-small)}.core-card__outline{border:1px solid var(--core-color-active)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { paddingSize: [{
                type: Input
            }], neumorphic: [{
                type: Input
            }], cardEl: [{
                type: ViewChild,
                args: ['cardEl']
            }], overridePadding: [{
                type: Input
            }], topAndBottomShadow: [{
                type: Input
            }] } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreCardModule {
}
CoreCardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreCardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreCardModule, declarations: [CoreCard], imports: [CommonModule], exports: [CoreCard] });
CoreCardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCardModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCardModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreCard],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreCard]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class PressableDirective {
    constructor(element, renderer) {
        this.element = element;
        this.renderer = renderer;
    }
    // @HostListener('document:mouseup', ['$event'])
    // clickStop() {
    //   console.log("tset")
    //   this.setPressed(false);
    // }
    ngOnInit() {
        this.renderer.setStyle(this.element.nativeElement, 'transition', 'transform 180ms ease-in-out');
        this.element.nativeElement.addEventListener("mousedown", () => {
            this.setPressed(true);
        });
        this.element.nativeElement.addEventListener("touchstart", () => {
            this.setPressed(true);
        });
    }
    ngOnDestroy() {
        // Clean up
        // Remove event listeners causes problems with server side renderering
        // Modern browsers do garbage collection (IE 10+) on Event Listeners so
        // the practice of removing listeners is no longer necessary.
        // this.element.nativeElement.removeAllListeners();
    }
    setPressed(pressIn) {
        if (pressIn) {
            this.renderer.setStyle(this.element.nativeElement, 'transform', 'scale(0.90)');
        }
        else if (!pressIn) {
            this.renderer.setStyle(this.element.nativeElement, 'transform', 'scale(1)');
        }
    }
}
PressableDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: PressableDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
PressableDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: PressableDirective, selector: "[corePressable]", host: { listeners: { "document:mouseup": "setPressed(false)", "document:touchend": "setPressed(false)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: PressableDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[corePressable]',
                    host: {
                        '(document:mouseup)': 'setPressed(false)',
                        '(document:touchend)': 'setPressed(false)'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CorePressableModule {
}
CorePressableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CorePressableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CorePressableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CorePressableModule, declarations: [PressableDirective], imports: [CommonModule], exports: [PressableDirective] });
CorePressableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CorePressableModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CorePressableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [PressableDirective],
                    imports: [
                        CommonModule
                    ],
                    exports: [PressableDirective]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class ScrollLockService {
    constructor(platformId) {
        this.platformId = platformId;
        this.hasPassiveEvents = false;
        this.isIosDevice = false;
        this.locks = [];
        this.documentListenerAdded = false;
        this.initialClientY = -1;
        // returns true if `el` should be allowed to receive touchmove events.
        this.allowTouchMove = el => this.locks.some(lock => {
            if (lock.options.allowTouchMove && lock.options.allowTouchMove(el)) {
                return true;
            }
            return false;
        });
        this.preventDefault = rawEvent => {
            const e = rawEvent || window.event;
            // For the case whereby consumers adds a touchmove event listener to document.
            // Recall that we do document.addEventListener('touchmove', preventDefault, { passive: false })
            // in disableBodyScroll - so if we provide this opportunity to allowTouchMove, then
            // the touchmove event on document will break.
            if (this.allowTouchMove(e.target)) {
                return true;
            }
            // Do not prevent if the event has more than one touch (usually meaning this is a multi touch gesture like pinch to zoom).
            if (e.touches.length > 1)
                return true;
            if (e.preventDefault)
                e.preventDefault();
            return false;
        };
        this.setOverflowHidden = options => {
            // If previousBodyPaddingRight is already set, don't set it again.
            if (this.previousBodyPaddingRight === undefined) {
                const reserveScrollBarGap = !!options && options.reserveScrollBarGap === true;
                const scrollBarGap = window.innerWidth - document.documentElement.clientWidth;
                if (reserveScrollBarGap && scrollBarGap > 0) {
                    this.previousBodyPaddingRight = document.body.style.paddingRight;
                    document.body.style.paddingRight = `${scrollBarGap}px`;
                }
            }
            // If previousBodyOverflowSetting is already set, don't set it again.
            if (this.previousBodyOverflowSetting === undefined) {
                this.previousBodyOverflowSetting = document.body.style.overflow;
                document.body.style.overflow = 'hidden';
            }
        };
        this.restoreOverflowSetting = () => {
            if (this.previousBodyPaddingRight !== undefined) {
                document.body.style.paddingRight = this.previousBodyPaddingRight;
                // Restore previousBodyPaddingRight to undefined so setOverflowHidden knows it
                // can be set again.
                this.previousBodyPaddingRight = undefined;
            }
            if (this.previousBodyOverflowSetting !== undefined) {
                document.body.style.overflow = this.previousBodyOverflowSetting;
                // Restore previousBodyOverflowSetting to undefined
                // so setOverflowHidden knows it can be set again.
                this.previousBodyOverflowSetting = undefined;
            }
        };
        // https://developer.mozilla.org/en-US/docs/Web/API/Element/scrollHeight#Problems_and_solutions
        this.isTargetElementTotallyScrolled = targetElement => targetElement ? targetElement.scrollHeight - targetElement.scrollTop <= targetElement.clientHeight : false;
        this.handleScroll = (event, targetElement) => {
            const clientY = event.targetTouches[0].clientY - this.initialClientY;
            if (this.allowTouchMove(event.target)) {
                return false;
            }
            if (targetElement && targetElement.scrollTop === 0 && clientY > 0) {
                // element is at the top of its scroll.
                return this.preventDefault(event);
            }
            if (this.isTargetElementTotallyScrolled(targetElement) && clientY < 0) {
                // element is at the bottom of its scroll.
                return this.preventDefault(event);
            }
            event.stopPropagation();
            return true;
        };
        this.disableBodyScroll = (targetElement, options) => {
            if (!isPlatformBrowser(this.platformId)) {
                return;
            }
            // targetElement must be provided
            if (!targetElement) {
                // eslint-disable-next-line no-console
                console.error('disableBodyScroll unsuccessful - targetElement must be provided when calling disableBodyScroll on IOS devices.');
                return;
            }
            // disableBodyScroll must not have been called on this targetElement before
            if (this.locks.some(lock => lock.targetElement === targetElement)) {
                return;
            }
            const lock = {
                targetElement,
                options: options || {}
            };
            this.locks = [...this.locks, lock];
            if (this.isIosDevice) {
                targetElement.ontouchstart = event => {
                    if (event.targetTouches.length === 1) {
                        // detect single touch.
                        this.initialClientY = event.targetTouches[0].clientY;
                    }
                };
                targetElement.ontouchmove = event => {
                    if (event.targetTouches.length === 1) {
                        // detect single touch.
                        this.handleScroll(event, targetElement);
                    }
                };
                if (!this.documentListenerAdded) {
                    document.addEventListener('touchmove', this.preventDefault, this.hasPassiveEvents ? false : undefined);
                    this.documentListenerAdded = true;
                }
            }
            else {
                this.setOverflowHidden(options);
            }
        };
        this.clearAllBodyScrollLocks = () => {
            if (!isPlatformBrowser(this.platformId)) {
                return;
            }
            if (this.isIosDevice) {
                // Clear all locks ontouchstart/ontouchmove handlers, and the references.
                this.locks.forEach(lock => {
                    lock.targetElement.ontouchstart = null;
                    lock.targetElement.ontouchmove = null;
                });
                if (this.documentListenerAdded) {
                    document.removeEventListener('touchmove', this.preventDefault, this.hasPassiveEvents ? false : undefined);
                    this.documentListenerAdded = false;
                }
                // Reset initial clientY.
                this.initialClientY = -1;
            }
            else {
                this.restoreOverflowSetting();
            }
            this.locks = [];
        };
        this.enableBodyScroll = targetElement => {
            if (!isPlatformBrowser(this.platformId)) {
                return;
            }
            if (!targetElement) {
                // eslint-disable-next-line no-console
                console.error('enableBodyScroll unsuccessful - targetElement must be provided when calling enableBodyScroll on IOS devices.');
                return;
            }
            this.locks = this.locks.filter(lock => lock.targetElement !== targetElement);
            if (this.isIosDevice) {
                targetElement.ontouchstart = null;
                targetElement.ontouchmove = null;
                if (this.documentListenerAdded && this.locks.length === 0) {
                    document.removeEventListener('touchmove', this.preventDefault, this.hasPassiveEvents ? false : undefined);
                    this.documentListenerAdded = false;
                }
            }
            else if (!this.locks.length) {
                this.restoreOverflowSetting();
            }
        };
    }
    get passiveTestOptions() {
        this.hasPassiveEvents = true;
        return undefined;
    }
    ;
    ngOnInit() {
        if (!isPlatformBrowser(this.platformId)) {
            return;
        }
        if (typeof window !== 'undefined') {
            window.addEventListener('testPassive', null, this.passiveTestOptions);
            window.removeEventListener('testPassive', null, this.passiveTestOptions);
        }
        this.isIosDevice = typeof window !== 'undefined' && window.navigator && window.navigator.platform && (/iP(ad|hone|od)/.test(window.navigator.platform) || window.navigator.platform === 'MacIntel' && window.navigator.maxTouchPoints > 1);
    }
}
ScrollLockService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ScrollLockService, deps: [{ token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Injectable });
ScrollLockService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ScrollLockService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ScrollLockService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }];
    } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class ClickOutsideDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.onClickOutside = new EventEmitter();
    }
    onClick(event, targetElement) {
        if (!targetElement) {
            return;
        }
        const clickedInside = this.elementRef.nativeElement.contains(targetElement);
        if (!clickedInside) {
            this.onClickOutside.emit(event);
        }
    }
}
ClickOutsideDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ClickOutsideDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ClickOutsideDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: ClickOutsideDirective, selector: "[coreClickOutside]", inputs: { coreClickOutside: "coreClickOutside" }, outputs: { onClickOutside: "onClickOutside" }, host: { listeners: { "document:click": "onClick($event,$event.target)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ClickOutsideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[coreClickOutside]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { coreClickOutside: [{
                type: Input
            }], onClickOutside: [{
                type: Output
            }], onClick: [{
                type: HostListener,
                args: ['document:click', ['$event', '$event.target']]
            }] } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreModal {
    constructor(renderer, platformId, scrollLockService) {
        this.renderer = renderer;
        this.platformId = platformId;
        this.scrollLockService = scrollLockService;
        this._open = false;
        this.isOpening = false;
        this.action = false;
        this.title = false;
        this.actionPrimary = true;
        this.actionSecondary = true;
        this.primaryButtonPressed = new EventEmitter();
        this.secondaryButtonPressed = new EventEmitter();
        this.viewInitialized = false;
    }
    get open() {
        return this._open;
    }
    set open(val) {
        // Do not proceed unless the view is initialized because there will be no context to the modal element
        if (!this.viewInitialized) {
            return;
        }
        if (val === true) {
            this._open = val;
            // Must wait until the component view is rendered before disabling scroll
            setTimeout(() => {
                this.scrollLockService.disableBodyScroll(this.modalElement.nativeElement);
            }, 1);
        }
        else {
            this.scrollLockService.enableBodyScroll(this.modalElement.nativeElement);
            // Must wait until the body scroll is disabled before destorying the component render
            setTimeout(() => {
                this._open = val;
            }, 1);
        }
    }
    ngAfterViewInit() {
        this.toggleModal(this.open);
        this.viewInitialized = true;
    }
    toggleModal(on) {
        if (!isPlatformBrowser(this.platformId)) {
            return;
        }
        if (!on && !this.isOpening) {
            this.open = false;
            // this.closeModal();
        }
        else if (on) {
            this.isOpening = true;
            this.open = true;
            // Delay
            setTimeout(() => {
                this.isOpening = false;
            }, 10);
        }
    }
    openModal() {
        this.renderer.setStyle(this.modalElement.nativeElement, "display", "flex");
    }
    closeModal() {
        this.renderer.setStyle(this.modalElement.nativeElement, "display", "none");
    }
    ngOnDestroy() {
        this.scrollLockService.clearAllBodyScrollLocks();
    }
}
CoreModal.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModal, deps: [{ token: i0.Renderer2 }, { token: PLATFORM_ID }, { token: ScrollLockService }], target: i0.ɵɵFactoryTarget.Component });
CoreModal.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreModal, selector: "core-modal", inputs: { action: "action", title: "title", actionPrimary: "actionPrimary", actionSecondary: "actionSecondary" }, outputs: { primaryButtonPressed: "primaryButtonPressed", secondaryButtonPressed: "secondaryButtonPressed" }, viewQueries: [{ propertyName: "modalElement", first: true, predicate: ["modalElement"], descendants: true }], exportAs: ["coreModal"], ngImport: i0, template: `
    <div class="modal__container" #modalElement *ngIf="open">
      <div class="modal" coreClickOutside (onClickOutside)="toggleModal(false)">
        <div class="title" *ngIf="title">
          <h2><ng-content select="span[coreModalTitle]"></ng-content></h2>
        </div>
        <div class="content">
          <ng-content></ng-content>
        </div>
        <div class="action" *ngIf="action">
          <span>
            <ng-content select="span[coreModalActionPrimary]"></ng-content>
          </span>
          <span>
            <ng-content select="span[coreModalActionSecondary]"></ng-content>
          </span>
        </div>
      </div>
    </div>`, isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n *//**\n* @license\n* Copyright 2021 SimpleCore All Rights Reserved.\n*\n* Use of this source code is governed private licensing for\n* internal SimpleCore projects\n*/.modal__container{position:fixed;width:100%;height:100%;display:flex;z-index:100;justify-content:center;align-items:center;top:0;left:0;animation:.15s ease-out 0s 1 fadeBackground forwards}.modal__container .modal{animation:.15s 0s 1 ease-in-out delayShow forwards;width:400px;border-radius:var(--border-radius-action);background-color:var(--core-color-light);box-shadow:0 2px 10px 0 var(--core-active-gray);--modal-padding: 12px}.modal__container .modal .title{padding:var(--modal-padding)}.modal__container .modal .title h2{margin:0;padding:0}.modal__container .modal .content{border-top:1px solid var(--core-active-gray);padding:var(--modal-padding)}.modal__container .modal .action{border-top:1px solid var(--core-active-gray);padding:var(--modal-padding);display:flex;flex-direction:row-reverse}.modal__container .modal .action span{margin-left:5px;font-size:14px}@keyframes fadeBackground{0%{background-color:#0000}to{background-color:#0003}}@keyframes delayShow{0%{visibility:hidden;transform:scale(.8)}to{visibility:visible;transform:scale(1)}}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: ClickOutsideDirective, selector: "[coreClickOutside]", inputs: ["coreClickOutside"], outputs: ["onClickOutside"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModal, decorators: [{
            type: Component,
            args: [{ selector: 'core-modal', exportAs: 'coreModal', template: `
    <div class="modal__container" #modalElement *ngIf="open">
      <div class="modal" coreClickOutside (onClickOutside)="toggleModal(false)">
        <div class="title" *ngIf="title">
          <h2><ng-content select="span[coreModalTitle]"></ng-content></h2>
        </div>
        <div class="content">
          <ng-content></ng-content>
        </div>
        <div class="action" *ngIf="action">
          <span>
            <ng-content select="span[coreModalActionPrimary]"></ng-content>
          </span>
          <span>
            <ng-content select="span[coreModalActionSecondary]"></ng-content>
          </span>
        </div>
      </div>
    </div>`, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n *//**\n* @license\n* Copyright 2021 SimpleCore All Rights Reserved.\n*\n* Use of this source code is governed private licensing for\n* internal SimpleCore projects\n*/.modal__container{position:fixed;width:100%;height:100%;display:flex;z-index:100;justify-content:center;align-items:center;top:0;left:0;animation:.15s ease-out 0s 1 fadeBackground forwards}.modal__container .modal{animation:.15s 0s 1 ease-in-out delayShow forwards;width:400px;border-radius:var(--border-radius-action);background-color:var(--core-color-light);box-shadow:0 2px 10px 0 var(--core-active-gray);--modal-padding: 12px}.modal__container .modal .title{padding:var(--modal-padding)}.modal__container .modal .title h2{margin:0;padding:0}.modal__container .modal .content{border-top:1px solid var(--core-active-gray);padding:var(--modal-padding)}.modal__container .modal .action{border-top:1px solid var(--core-active-gray);padding:var(--modal-padding);display:flex;flex-direction:row-reverse}.modal__container .modal .action span{margin-left:5px;font-size:14px}@keyframes fadeBackground{0%{background-color:#0000}to{background-color:#0003}}@keyframes delayShow{0%{visibility:hidden;transform:scale(.8)}to{visibility:visible;transform:scale(1)}}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.Renderer2 }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }, { type: ScrollLockService }];
    }, propDecorators: { action: [{
                type: Input
            }], title: [{
                type: Input
            }], actionPrimary: [{
                type: Input
            }], actionSecondary: [{
                type: Input
            }], primaryButtonPressed: [{
                type: Output
            }], secondaryButtonPressed: [{
                type: Output
            }], modalElement: [{
                type: ViewChild,
                args: ['modalElement']
            }] } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreClickOutsideModule {
}
CoreClickOutsideModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreClickOutsideModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreClickOutsideModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreClickOutsideModule, declarations: [ClickOutsideDirective], imports: [CommonModule], exports: [ClickOutsideDirective] });
CoreClickOutsideModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreClickOutsideModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreClickOutsideModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ClickOutsideDirective],
                    imports: [
                        CommonModule
                    ],
                    exports: [ClickOutsideDirective]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreModalModule {
}
CoreModalModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreModalModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreModalModule, declarations: [CoreModal], imports: [CommonModule,
        CoreClickOutsideModule,
        CoreButtonModule], exports: [CoreModal] });
CoreModalModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalModule, imports: [CommonModule,
        CoreClickOutsideModule,
        CoreButtonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreModal],
                    imports: [
                        CommonModule,
                        CoreClickOutsideModule,
                        CoreButtonModule
                    ],
                    exports: [CoreModal]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

class CoreProgressBar {
    constructor(renderer) {
        this.renderer = renderer;
        this.progressBarMode = 'indeterminate';
        this._value = 0;
        this.viewInitialized = false;
    }
    set value(val) {
        this._value = val;
        if (this.viewInitialized) {
            this.setDeterminateProgress(val);
        }
    }
    ;
    ngOnInit() {
    }
    ngAfterViewInit() {
        // Setup options
        switch (this.progressBarMode) {
            case "determinate":
                this.setDeterminateProgress(this._value);
                break;
            default:
                this.renderer.addClass(this.slider.nativeElement, "increase");
                break;
        }
        if (this.color !== undefined) {
            this.renderer.setStyle(this.mainLine.nativeElement, "background-color", `#${this.color}`);
            this.renderer.setStyle(this.sliderSecondary.nativeElement, "background-color", `#${this.color}`);
            this.renderer.setStyle(this.slider.nativeElement, "background-color", `#${this.color}`);
        }
        this.viewInitialized = true;
    }
    setDeterminateProgress(valuePercentage) {
        this.renderer.setStyle(this.slider.nativeElement, "width", `${valuePercentage}%`);
    }
}
CoreProgressBar.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBar, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CoreProgressBar.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreProgressBar, selector: "core-progress-bar", inputs: { color: "color", progressBarMode: "progressBarMode", value: "value" }, viewQueries: [{ propertyName: "slider", first: true, predicate: ["sliderSubLine"], descendants: true }, { propertyName: "mainLine", first: true, predicate: ["mainLine"], descendants: true }, { propertyName: "sliderSecondary", first: true, predicate: ["sliderSubLineSecondary"], descendants: true }], exportAs: ["coreProgressBar"], ngImport: i0, template: `
    <div class="slider">
      <div #mainLine class="line"></div>
      <div #sliderSubLine class="subLine"></div>
      <div #sliderSubLineSecondary *ngIf="progressBarMode === 'indeterminate'" class="subLine decrease"></div>
    </div>
  `, isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.slider{width:100%;height:5px;left:0;overflow-x:hidden;z-index:100}.line{opacity:.4;background-color:var(--core-color-secondary);width:150%;height:5px}.subLine{margin-top:-5px;background-color:var(--core-color-secondary);height:5px}.increase{animation:increase 2s infinite}.decrease{animation:decrease 2s .5s infinite}@keyframes increase{0%{margin-left:-5%;width:5%}to{margin-left:130%;width:100%}}@keyframes decrease{0%{margin-left:-80%;width:80%}to{margin-left:110%;width:10%}}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBar, decorators: [{
            type: Component,
            args: [{ selector: 'core-progress-bar', exportAs: 'coreProgressBar', template: `
    <div class="slider">
      <div #mainLine class="line"></div>
      <div #sliderSubLine class="subLine"></div>
      <div #sliderSubLineSecondary *ngIf="progressBarMode === 'indeterminate'" class="subLine decrease"></div>
    </div>
  `, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.slider{width:100%;height:5px;left:0;overflow-x:hidden;z-index:100}.line{opacity:.4;background-color:var(--core-color-secondary);width:150%;height:5px}.subLine{margin-top:-5px;background-color:var(--core-color-secondary);height:5px}.increase{animation:increase 2s infinite}.decrease{animation:decrease 2s .5s infinite}@keyframes increase{0%{margin-left:-5%;width:5%}to{margin-left:130%;width:100%}}@keyframes decrease{0%{margin-left:-80%;width:80%}to{margin-left:110%;width:10%}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { color: [{
                type: Input
            }], progressBarMode: [{
                type: Input
            }], value: [{
                type: Input
            }], slider: [{
                type: ViewChild,
                args: ['sliderSubLine']
            }], mainLine: [{
                type: ViewChild,
                args: ['mainLine']
            }], sliderSecondary: [{
                type: ViewChild,
                args: ['sliderSubLineSecondary']
            }] } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreProgressBarModule {
}
CoreProgressBarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreProgressBarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBarModule, declarations: [CoreProgressBar], imports: [CommonModule], exports: [CoreProgressBar] });
CoreProgressBarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBarModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreProgressBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreProgressBar],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreProgressBar]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

class Uuid {
    static getUuidString() {
        return Uuid.generateStringId(5) + Math.floor(Math.random() * Date.now());
    }
    static getUuidNumber() {
        return Math.floor(Math.random() * Date.now());
    }
    static generateStringId(length) {
        let result = '';
        const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        const charactersLength = characters.length;
        for (let i = 0; i < length; i++) {
            result += characters.charAt(Math.floor(Math.random() * charactersLength));
        }
        return result;
    }
}

class CalculateBackgroundColor {
    /** Note that this is a fairly intensive recursive function */
    static findElementBackground(element) {
        // Base case: Check if this element is a body element
        if (element === null || element === undefined) {
            return null;
        }
        const currentBackgroundColor = getComputedStyle(element).backgroundColor;
        // Is not default background color
        if (currentBackgroundColor !== 'rgba(0, 0, 0, 0)') {
            // This is this closest parent's background
            return currentBackgroundColor;
        }
        // Recursively find background color with parent element
        return CalculateBackgroundColor.findElementBackground(element.parentElement);
    }
}

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
/** Change event object emitted by CoreCheckbox. */
class CoreCheckboxChange {
}
/**
 * Provider Expression that allows core-checkbox to register as a ControlValueAccessor.
 * This allows it to support the FormsModule and [(ngModel)].
 */
const CORE_CHECKBOX_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => CoreCheckbox),
    multi: true
};
class CoreCheckbox {
    constructor(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        /**
         * Attached to the aria-label attribute of the host element. In most cases, aria-labelledby will
         * take precedence so this may be omitted.
         */
        this.ariaLabel = '';
        /**
         * Users can specify the `aria-labelledby` attribute which will be forwarded to the input element
         */
        this.ariaLabelledby = null;
        this._uniqueId = `core-checkbox-${Uuid.getUuidNumber()}`;
        /** A unique id for the checkbox input. If none is supplied, it will be auto-generated. */
        this.id = this._uniqueId;
        /** Whether the label should appear after or before the checkbox. Defaults to 'after' */
        this.labelPosition = 'after';
        /** Name value will be applied to the input element if present */
        this.name = null;
        /** Event emitted when the checkbox's `checked` value changes. */
        this.change = new EventEmitter();
        /** Event emitted when the checkbox's `indeterminate` value changes. */
        this.indeterminateChange = new EventEmitter();
        this._checked = false;
        this._disabled = false;
        this.checkboxSize = "15px";
        this.backgroundColor = "";
        /**
         * Called when the checkbox is blurred. Needed to properly implement ControlValueAccessor.
         */
        this._onTouched = () => { };
        this._controlValueAccessorChangeFn = () => { };
    }
    /** Returns the unique id for the visual hidden input. */
    get inputId() { return `${this.id || this._uniqueId}-input`; }
    /**
     * Whether the checkbox is checked.
     */
    get checked() { return this._checked; }
    set checked(value) {
        if (value !== this.checked) {
            this._checked = value;
            this._changeDetectorRef.markForCheck();
        }
    }
    /**
     * Whether the checkbox is disabled. This fully overrides the implementation provided by
     * mixinDisabled, but the mixin is still required because mixinTabIndex requires it.
     */
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = value != null && `${value}` !== 'false';
        if (newValue !== this.disabled) {
            this._disabled = newValue;
            this._changeDetectorRef.markForCheck();
        }
    }
    ngAfterViewInit() {
        this.labelElement.nativeElement.style.setProperty('--core-checkbox-size', this.checkboxSize);
        if (this.backgroundColor === "") {
            this.backgroundColor = CalculateBackgroundColor.findElementBackground(this.labelElement.nativeElement);
        }
        this.labelElement.nativeElement.style.setProperty('--core-checkbox-background', this.backgroundColor);
    }
    getAriaChecked() {
        if (this.checked) {
            return 'true';
        }
        return 'false';
    }
    onInputClick(event) {
        this.toggle();
        // Emit our custom change event if the native input emitted one.
        // It is important to only emit it, if the native input triggered one, because
        // we don't want to trigger a change event, when the `checked` variable changes for example.
        this._emitChangeEvent();
        this._inputElement.nativeElement.checked = this.checked;
    }
    _emitChangeEvent() {
        const event = new CoreCheckboxChange();
        event.source = this;
        event.checked = this.checked;
        this._controlValueAccessorChangeFn(this.checked);
        this.change.emit(event);
    }
    /** Toggles the `checked` state of the checkbox. */
    toggle() {
        this.checked = !this.checked;
    }
    // Implemented as part of ControlValueAccessor.
    writeValue(value) {
        this.checked = !!value;
    }
    // Implemented as part of ControlValueAccessor.
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    // Implemented as part of ControlValueAccessor.
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    // Implemented as part of ControlValueAccessor.
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
CoreCheckbox.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckbox, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
CoreCheckbox.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreCheckbox, selector: "core-checkbox", inputs: { color: "color", tabIndex: "tabIndex", ariaLabel: ["aria-label", "ariaLabel"], ariaLabelledby: ["aria-labelledby", "ariaLabelledby"], ariaDescribedby: ["aria-describedby", "ariaDescribedby"], id: "id", required: "required", labelPosition: "labelPosition", name: "name", value: "value", checked: "checked", disabled: "disabled", checkboxSize: "checkboxSize", backgroundColor: "backgroundColor" }, outputs: { change: "change", indeterminateChange: "indeterminateChange" }, providers: [CORE_CHECKBOX_CONTROL_VALUE_ACCESSOR], viewQueries: [{ propertyName: "labelElement", first: true, predicate: ["labelElement"], descendants: true }, { propertyName: "_inputElement", first: true, predicate: ["inputElement"], descendants: true }], exportAs: ["coreCheckbox"], ngImport: i0, template: `
    <span class="checkbox-container">
      <input type="checkbox"
             #inputElement
             [id]="inputId"
             [required]="required"
             [checked]="checked"
             [attr.value]="value"
             [disabled]="disabled"
             [attr.name]="name"
             [tabIndex]="tabIndex"
             [attr.aria-label]="ariaLabel || null"
             [attr.aria-labelledby]="ariaLabelledby"
             [attr.aria-checked]="getAriaChecked()"
             [attr.aria-describedby]="ariaDescribedby"
             (click)="onInputClick($event)"/>
      <label #labelElement [for]="inputId" class="animated-checkbox"></label>
      <label class="checkbox-label" [for]="inputId"><ng-content></ng-content></label>
    </span>
  `, isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.checkbox-container{display:flex;align-items:center}@keyframes checkmarkBottomHalf{0%{height:0}to{height:calc(var(--core-checkbox-size) / 2)}}@keyframes checkmarkTopHalf{0%{height:0}50%{height:0}to{height:calc(var(--core-checkbox-size) * 1.2)}}input[type=checkbox]{display:none}.animated-checkbox{margin-right:8px;height:var(--core-checkbox-size);width:var(--core-checkbox-size);background-color:transparent;border:calc(var(--core-checkbox-size) * .1) solid var(--core-active-gray);border-radius:16%;position:relative;display:inline-block;box-sizing:border-box;transition:border-color ease .12s;cursor:pointer;--core-checkbox-background: var(--core-background-color)}.animated-checkbox:before,.animated-checkbox:after{box-sizing:border-box;position:absolute;height:0;width:calc(var(--core-checkbox-size) * .2);background-color:var(--core-color-success);display:inline-block;transform-origin:left top;border-radius:5px;content:\" \";transition:opacity ease .5}.animated-checkbox:before{top:calc(var(--core-checkbox-size) * .72);left:calc(var(--core-checkbox-size) * .41);box-shadow:0 0 0 calc(var(--core-checkbox-size) * .05) var(--core-checkbox-background);transform:rotate(-135deg)}.animated-checkbox:after{top:calc(var(--core-checkbox-size) * .37);left:calc(var(--core-checkbox-size) * .05);transform:rotate(-45deg)}.animated-checkbox:hover{border-color:var(--core-color-dark)}input[type=checkbox]:checked+.animated-checkbox,.animated-checkbox.checked{border-color:var(--core-color-success)}input[type=checkbox]:checked+.animated-checkbox:after,.animated-checkbox.checked:after{height:calc(var(--core-checkbox-size) * .5);animation:checkmarkBottomHalf .12s ease 0s forwards}input[type=checkbox]:checked+.animated-checkbox:before,.animated-checkbox.checked:before{height:calc(var(--core-checkbox-size) * 1.2);animation:checkmarkTopHalf .24s ease 0s forwards}.checkbox-label{cursor:pointer;color:var(--core-color-dark)}.checkbox-label:hover~.animated-checkbox{border-color:var(--core-color-dark)}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckbox, decorators: [{
            type: Component,
            args: [{ selector: 'core-checkbox', exportAs: 'coreCheckbox', template: `
    <span class="checkbox-container">
      <input type="checkbox"
             #inputElement
             [id]="inputId"
             [required]="required"
             [checked]="checked"
             [attr.value]="value"
             [disabled]="disabled"
             [attr.name]="name"
             [tabIndex]="tabIndex"
             [attr.aria-label]="ariaLabel || null"
             [attr.aria-labelledby]="ariaLabelledby"
             [attr.aria-checked]="getAriaChecked()"
             [attr.aria-describedby]="ariaDescribedby"
             (click)="onInputClick($event)"/>
      <label #labelElement [for]="inputId" class="animated-checkbox"></label>
      <label class="checkbox-label" [for]="inputId"><ng-content></ng-content></label>
    </span>
  `, inputs: ['color', 'tabIndex'], providers: [CORE_CHECKBOX_CONTROL_VALUE_ACCESSOR], styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.checkbox-container{display:flex;align-items:center}@keyframes checkmarkBottomHalf{0%{height:0}to{height:calc(var(--core-checkbox-size) / 2)}}@keyframes checkmarkTopHalf{0%{height:0}50%{height:0}to{height:calc(var(--core-checkbox-size) * 1.2)}}input[type=checkbox]{display:none}.animated-checkbox{margin-right:8px;height:var(--core-checkbox-size);width:var(--core-checkbox-size);background-color:transparent;border:calc(var(--core-checkbox-size) * .1) solid var(--core-active-gray);border-radius:16%;position:relative;display:inline-block;box-sizing:border-box;transition:border-color ease .12s;cursor:pointer;--core-checkbox-background: var(--core-background-color)}.animated-checkbox:before,.animated-checkbox:after{box-sizing:border-box;position:absolute;height:0;width:calc(var(--core-checkbox-size) * .2);background-color:var(--core-color-success);display:inline-block;transform-origin:left top;border-radius:5px;content:\" \";transition:opacity ease .5}.animated-checkbox:before{top:calc(var(--core-checkbox-size) * .72);left:calc(var(--core-checkbox-size) * .41);box-shadow:0 0 0 calc(var(--core-checkbox-size) * .05) var(--core-checkbox-background);transform:rotate(-135deg)}.animated-checkbox:after{top:calc(var(--core-checkbox-size) * .37);left:calc(var(--core-checkbox-size) * .05);transform:rotate(-45deg)}.animated-checkbox:hover{border-color:var(--core-color-dark)}input[type=checkbox]:checked+.animated-checkbox,.animated-checkbox.checked{border-color:var(--core-color-success)}input[type=checkbox]:checked+.animated-checkbox:after,.animated-checkbox.checked:after{height:calc(var(--core-checkbox-size) * .5);animation:checkmarkBottomHalf .12s ease 0s forwards}input[type=checkbox]:checked+.animated-checkbox:before,.animated-checkbox.checked:before{height:calc(var(--core-checkbox-size) * 1.2);animation:checkmarkTopHalf .24s ease 0s forwards}.checkbox-label{cursor:pointer;color:var(--core-color-dark)}.checkbox-label:hover~.animated-checkbox{border-color:var(--core-color-dark)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { ariaLabel: [{
                type: Input,
                args: ['aria-label']
            }], ariaLabelledby: [{
                type: Input,
                args: ['aria-labelledby']
            }], ariaDescribedby: [{
                type: Input,
                args: ['aria-describedby']
            }], id: [{
                type: Input
            }], required: [{
                type: Input
            }], labelPosition: [{
                type: Input
            }], name: [{
                type: Input
            }], change: [{
                type: Output
            }], indeterminateChange: [{
                type: Output
            }], value: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], checked: [{
                type: Input
            }], disabled: [{
                type: Input
            }], checkboxSize: [{
                type: Input
            }], backgroundColor: [{
                type: Input
            }], labelElement: [{
                type: ViewChild,
                args: ['labelElement']
            }], _inputElement: [{
                type: ViewChild,
                args: ['inputElement']
            }] } });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreCheckboxModule {
}
CoreCheckboxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreCheckboxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckboxModule, declarations: [CoreCheckbox], imports: [CommonModule], exports: [CoreCheckbox] });
CoreCheckboxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckboxModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreCheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreCheckbox],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreCheckbox]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

class RendererExtensions {
    static addClassToChildren(renderer, element, className) {
        const stackChildren = element.children;
        for (let i = 0; i < stackChildren.length; i++) {
            renderer.addClass(stackChildren[i], className);
        }
    }
    static addStyleToChildren(renderer, element, styleName, styleValue, indexCondition) {
        if (styleName == "") {
            return;
        }
        const stackChildren = element.children;
        let indexToAvoid = [];
        if (indexCondition !== null && indexCondition !== undefined) {
            stackChildren.length;
            for (let i = 0; i < stackChildren.length; i++) {
                if (indexCondition(i, stackChildren) == false) {
                    indexToAvoid.push(i);
                }
            }
        }
        for (let i = 0; i < stackChildren.length; i++) {
            if (!indexToAvoid.includes(i)) {
                renderer.setStyle(stackChildren[i], styleName, styleValue);
            }
        }
    }
}

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreVStack {
    constructor(renderer) {
        this.renderer = renderer;
        this.marginSize = "medium";
        this.alignItems = "start";
    }
    ngAfterViewInit() {
        this.renderer.setStyle(this.vStack.nativeElement, "align-items", `${this.alignItems}`);
        if (this.overrideMarginSize === undefined) {
            RendererExtensions.addStyleToChildren(this.renderer, this.vStack.nativeElement, "margin-bottom", `var(--core-stack-margin-${this.marginSize})`, avoidLast);
        }
        else {
            RendererExtensions.addStyleToChildren(this.renderer, this.vStack.nativeElement, "margin-bottom", `${this.overrideMarginSize}px`, avoidLast);
        }
    }
}
CoreVStack.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreVStack, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CoreVStack.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreVStack, selector: "core-vstack", inputs: { overrideMarginSize: "overrideMarginSize", marginSize: "marginSize", alignItems: "alignItems" }, viewQueries: [{ propertyName: "vStack", first: true, predicate: ["vStack"], descendants: true }], exportAs: ["coreVStack"], ngImport: i0, template: '<div #vStack class="core-vstack"><ng-content></ng-content></div>', isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-vstack{display:flex;flex-direction:column}.core-hstack{display:flex}.core-hstack-wrap{display:flex;flex-wrap:wrap}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreVStack, decorators: [{
            type: Component,
            args: [{ selector: 'core-vstack', exportAs: 'coreVStack', template: '<div #vStack class="core-vstack"><ng-content></ng-content></div>', encapsulation: ViewEncapsulation.None, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-vstack{display:flex;flex-direction:column}.core-hstack{display:flex}.core-hstack-wrap{display:flex;flex-wrap:wrap}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { vStack: [{
                type: ViewChild,
                args: ['vStack']
            }], overrideMarginSize: [{
                type: Input
            }], marginSize: [{
                type: Input
            }], alignItems: [{
                type: Input
            }] } });
class CoreHStack {
    constructor(renderer) {
        this.renderer = renderer;
        this.marginSize = "medium";
        this.alignItems = "start";
    }
    ngAfterViewInit() {
        this.renderer.setStyle(this.hStack.nativeElement, "align-items", `${this.alignItems}`);
        if (this.overrideMarginSize === undefined) {
            RendererExtensions.addStyleToChildren(this.renderer, this.hStack.nativeElement, "margin-right", `var(--core-stack-margin-${this.marginSize})`, avoidLast);
        }
        else {
            RendererExtensions.addStyleToChildren(this.renderer, this.hStack.nativeElement, "margin-right", `${this.overrideMarginSize}px`, avoidLast);
        }
    }
}
CoreHStack.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreHStack, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CoreHStack.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: CoreHStack, selector: "core-hstack", inputs: { overrideMarginSize: "overrideMarginSize", marginSize: "marginSize", wrap: "wrap", alignItems: "alignItems" }, viewQueries: [{ propertyName: "hStack", first: true, predicate: ["hStack"], descendants: true }], exportAs: ["coreHStack"], ngImport: i0, template: `<div #hStack [class.core-hstack-wrap]="wrap" [class.core-hstack]="!wrap"><ng-content></ng-content></div>`, isInline: true, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-vstack{display:flex;flex-direction:column}.core-hstack{display:flex}.core-hstack-wrap{display:flex;flex-wrap:wrap}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreHStack, decorators: [{
            type: Component,
            args: [{ selector: 'core-hstack', exportAs: 'coreHStack', template: `<div #hStack [class.core-hstack-wrap]="wrap" [class.core-hstack]="!wrap"><ng-content></ng-content></div>`, encapsulation: ViewEncapsulation.None, styles: ["/**\n * @license\n * Copyright 2021 SimpleCore All Rights Reserved.\n *\n * Use of this source code is governed private licensing for\n * internal SimpleCore projects\n */.core-vstack{display:flex;flex-direction:column}.core-hstack{display:flex}.core-hstack-wrap{display:flex;flex-wrap:wrap}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { hStack: [{
                type: ViewChild,
                args: ['hStack']
            }], overrideMarginSize: [{
                type: Input
            }], marginSize: [{
                type: Input
            }], wrap: [{
                type: Input
            }], alignItems: [{
                type: Input
            }] } });
const avoidLast = (i, array) => {
    return i != array.length - 1;
};

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
class CoreStackModule {
}
CoreStackModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreStackModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreStackModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreStackModule, declarations: [CoreVStack, CoreHStack], imports: [CommonModule], exports: [CoreVStack, CoreHStack] });
CoreStackModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreStackModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreStackModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CoreVStack, CoreHStack],
                    imports: [
                        CommonModule
                    ],
                    exports: [CoreVStack, CoreHStack]
                }]
        }] });

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

var Month;
(function (Month) {
    Month[Month["January"] = 0] = "January";
    Month[Month["February"] = 1] = "February";
    Month[Month["March"] = 2] = "March";
    Month[Month["April"] = 3] = "April";
    Month[Month["May"] = 4] = "May";
    Month[Month["June"] = 5] = "June";
    Month[Month["July"] = 6] = "July";
    Month[Month["August"] = 7] = "August";
    Month[Month["September"] = 8] = "September";
    Month[Month["October"] = 9] = "October";
    Month[Month["November"] = 10] = "November";
    Month[Month["December"] = 11] = "December";
})(Month || (Month = {}));

function memoize(memoizedFunction) {
    const cache = new Map();
    return (memoizedParameter) => {
        if (cache.has(memoizedParameter)) {
            return cache.get(memoizedParameter);
        }
        else {
            const result = memoizedFunction(memoizedParameter);
            cache.set(memoizedParameter, result);
            return result;
        }
    };
}

function setDay(date, dayOfWeek) {
    return addDays(date, dayOfWeek - date.getDay());
}
function addDays(date, days) {
    return setDate(date, date.getDate() + days);
}
function setDate(date, dayOfMonth) {
    const dateCopy = new Date(date);
    dateCopy.setDate(dayOfMonth);
    return dateCopy;
}
function addMonths(date, months) {
    return setMonth(date, date.getMonth() + months);
}
function setMonth(date, month) {
    const dateCopy = new Date(date);
    dateCopy.setMonth(month);
    return dateCopy;
}
function startOfDay(date) {
    return new Date(date.getFullYear(), date.getMonth(), date.getDate());
}
function startOfMonth(date) {
    return new Date(date.getFullYear(), date.getMonth(), 1);
}
function getDaysOfMonth(month) {
    return Array.from({ length: numberOfDaysInMonth(month) }, (_, index) => setDate(month, index + 1));
}
function numberOfDaysInMonth(date) {
    return new Date(date.getFullYear(), date.getMonth() + 1, 0).getDate();
}
function isSameDate(date1, date2) {
    return date1.getTime() === date2.getTime();
}
function areDatesInSameMonth(date1, date2) {
    return date1.getFullYear() === date2.getFullYear() && date1.getMonth() === date2.getMonth();
}
function isDateAfter(date1, date2) {
    return date1.getTime() > date2.getTime();
}
function isValidDate(value) {
    return value instanceof Date && typeof value.getTime === 'function' && !isNaN(value.getTime());
}
function toISODateString(date) {
    const offset = date.getTimezoneOffset();
    return new Date(date.getTime() - offset * 60 * 1000).toISOString().split('T')[0];
}
const monthAndYearFormatOptions = {
    year: 'numeric',
    month: 'long'
};
const localeDateFormatDayPart = /\s?d+(\.|,|\sde)?/;
const getFallbackLocaleMonthAndYearFormat = memoize((locale) => {
    return getLocaleDateFormat(locale, FormatWidth.Long).replace(localeDateFormatDayPart, '').trim();
});
const getLocaleMonthAndYearFormat = memoize((locale) => {
    if (Intl.DateTimeFormat.prototype.formatToParts) {
        const monthAndYearFormatter = new Intl.DateTimeFormat(locale, monthAndYearFormatOptions);
        return monthAndYearFormatter.formatToParts().map(({ type, value }) => {
            switch (type) {
                case 'year':
                    return 'y';
                case 'month':
                    return 'MMMM';
                case 'literal':
                    return `'${value}'`;
                default:
                    return '';
            }
        }).reduce((dateFormat, dateFormatPart) => dateFormat + dateFormatPart);
    }
    else {
        return getFallbackLocaleMonthAndYearFormat(locale);
    }
});
function toLocaleStringSupportsLocales() {
    try {
        new Date().toLocaleString('i');
    }
    catch (e) {
        return e instanceof RangeError;
    }
    return false;
}

const keyCodesToDaySteps = new Map([
    [RIGHT_ARROW, 1],
    [LEFT_ARROW, -1],
    [DOWN_ARROW, 7],
    [UP_ARROW, -7]
]);
class MonthComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.currentDate = startOfDay(new Date());
        this.dateSelector = 'time.month__date';
        this.selectedDateChange = new EventEmitter();
        this.activeDateChange = new EventEmitter();
    }
    get month() {
        return this._month;
    }
    set month(month) {
        if (!this._month || !areDatesInSameMonth(this._month, month)) {
            this._month = month;
            this.daysOfMonth = getDaysOfMonth(this._month);
            this.firstDayOfMonth = WeekDay[this.daysOfMonth[0].getDay()].toLowerCase();
        }
    }
    ngAfterViewInit() {
        this.changeDetectorRef.detach();
    }
    ngOnChanges(changes) {
        if (Object.entries(changes).some(([input, change]) => input !== 'month' && !change.firstChange)) {
            this.changeDetectorRef.detectChanges();
        }
    }
    isHighlighted(dayOfMonth) {
        return !!this.highlightedDate && isSameDate(dayOfMonth, this.highlightedDate);
    }
    isSelected(dayOfMonth) {
        return !!this.selectedDate && isSameDate(dayOfMonth, this.selectedDate);
    }
    isDisabled(dayOfMonth) {
        return !!this.min && isDateAfter(this.min, dayOfMonth);
    }
    isActive(dayOfMonth) {
        return !!this.activeDate && isSameDate(dayOfMonth, this.activeDate);
    }
    isCurrent(dayOfMonth) {
        return !!this.currentDate && isSameDate(dayOfMonth, this.currentDate);
    }
    onKeydown(event) {
        const dayStepDelta = keyCodesToDaySteps.get(event.keyCode);
        if (dayStepDelta) {
            event.preventDefault();
            const activeDate = addDays(this.activeDate, dayStepDelta);
            this.activeDateChange.emit(activeDate);
        }
    }
    onMonthClick(event) {
        // should be MouseEvent | KeyboardEvent, but $event type for keyup.enter is not inferred correctly
        const target = event.target;
        if (this.isTimeElement(target)) {
            this.onDateClick(target);
        }
    }
    onDateClick(timeElement) {
        const selectedDate = new Date(timeElement.dateTime + 'T00:00');
        if (isValidDate(selectedDate)) {
            this.selectDate(selectedDate);
        }
    }
    selectDate(date) {
        if (!this.isSelected(date) && !this.isDisabled(date)) {
            this.selectedDateChange.emit(date);
        }
    }
    isTimeElement(element) {
        return !!element && element.matches(this.dateSelector);
    }
}
MonthComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MonthComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: MonthComponent, selector: "lib-month", inputs: { selectedDate: "selectedDate", highlightedDate: "highlightedDate", min: "min", locale: "locale", activeDate: "activeDate", month: "month" }, outputs: { selectedDateChange: "selectedDateChange", activeDateChange: "activeDateChange" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"month\"\n     [ngClass]=\"[\n       'month--first-day-' + firstDayOfMonth\n     ]\"\n     (click)=\"onMonthClick($event)\"\n     (keyup.enter)=\"onMonthClick($event)\"\n     (keydown)=\"onKeydown($event)\"\n     role=\"listbox\"\n     tabindex=\"-1\"\n>\n  <time class=\"month__date\"\n        *ngFor=\"let dayOfMonth of daysOfMonth\"\n        [dateTime]=\"dayOfMonth | date:'yyyy-MM-dd'\"\n        [attr.aria-label]=\"dayOfMonth | date:'fullDate':undefined:locale\"\n        [class.month__date--selected]=\"isSelected(dayOfMonth)\"\n        [attr.aria-selected]=\"isSelected(dayOfMonth)\"\n        [class.month__date--disabled]=\"isDisabled(dayOfMonth)\"\n        [attr.aria-disabled]=\"isDisabled(dayOfMonth)\"\n        [class.month__date--active]=\"isActive(dayOfMonth)\"\n        [class.month__date--highlighted]=\"isHighlighted(dayOfMonth) && !isSelected(dayOfMonth)\"\n        [tabIndex]=\"isActive(dayOfMonth) ? 0 : -1\"\n        [attr.aria-current]=\"!isCurrent(dayOfMonth) && 'date'\"\n        role=\"option\"\n        [attr.cdkFocusInitial]=\"isActive(dayOfMonth) ? '' : null\"\n  >\n    {{dayOfMonth | date:'d'}}\n  </time>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}:host-context(.calendar--disabled)>*{opacity:.38;cursor:initial}.month{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem}@media (min-width: 360px){.month{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.month{width:auto;margin:0;line-height:initial;justify-content:center}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-sunday time:first-child{margin-left:calc(0 * var(--calendar-cell-size--accessible));grid-column:1}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-sunday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-monday time:first-child{margin-left:calc(1 * var(--calendar-cell-size--accessible));grid-column:2}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-monday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-tuesday time:first-child{margin-left:calc(2 * var(--calendar-cell-size--accessible));grid-column:3}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-tuesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-wednesday time:first-child{margin-left:calc(3 * var(--calendar-cell-size--accessible));grid-column:4}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-wednesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-thursday time:first-child{margin-left:calc(4 * var(--calendar-cell-size--accessible));grid-column:5}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-thursday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-friday time:first-child{margin-left:calc(5 * var(--calendar-cell-size--accessible));grid-column:6}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-friday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-saturday time:first-child{margin-left:calc(6 * var(--calendar-cell-size--accessible));grid-column:7}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-saturday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-monday time:first-child{margin-left:calc(0 * var(--calendar-cell-size--accessible));grid-column:1}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-monday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-tuesday time:first-child{margin-left:calc(1 * var(--calendar-cell-size--accessible));grid-column:2}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-tuesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-wednesday time:first-child{margin-left:calc(2 * var(--calendar-cell-size--accessible));grid-column:3}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-wednesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-thursday time:first-child{margin-left:calc(3 * var(--calendar-cell-size--accessible));grid-column:4}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-thursday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-friday time:first-child{margin-left:calc(4 * var(--calendar-cell-size--accessible));grid-column:5}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-friday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-saturday time:first-child{margin-left:calc(5 * var(--calendar-cell-size--accessible));grid-column:6}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-saturday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-sunday time:first-child{margin-left:calc(6 * var(--calendar-cell-size--accessible));grid-column:7}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-sunday time:first-child{margin-left:0}}.month__date{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;cursor:pointer}.month__date--active{background-color:rgba(var(--core-color-secondary-rgb),.4)}.month__date--selected{background-color:var(--core-color-primary)!important;color:var(--core-color-light)!important}.month__date--highlighted{background-color:rgba(var(--core-color-primary-rgb),.2);color:var(--core-color-primary)!important}.month__date--disabled{opacity:.38}:host-context(.calendar--disabled) .month__date{cursor:initial}.month .month__date{border-radius:50%;font-size:calc(var(--calendar-cell-size--accessible) / 2.5);font-weight:600;color:var(--core-color-dark);margin:calc(var(--calendar-cell-size--accessible) / 11.6);transition:background-color .3s cubic-bezier(.4,0,.2,1),color .3s cubic-bezier(.4,0,.2,1)}.month .month__date:hover{background-color:var(--core-light-gray)}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "pipe", type: i1.DatePipe, name: "date" }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-month', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"month\"\n     [ngClass]=\"[\n       'month--first-day-' + firstDayOfMonth\n     ]\"\n     (click)=\"onMonthClick($event)\"\n     (keyup.enter)=\"onMonthClick($event)\"\n     (keydown)=\"onKeydown($event)\"\n     role=\"listbox\"\n     tabindex=\"-1\"\n>\n  <time class=\"month__date\"\n        *ngFor=\"let dayOfMonth of daysOfMonth\"\n        [dateTime]=\"dayOfMonth | date:'yyyy-MM-dd'\"\n        [attr.aria-label]=\"dayOfMonth | date:'fullDate':undefined:locale\"\n        [class.month__date--selected]=\"isSelected(dayOfMonth)\"\n        [attr.aria-selected]=\"isSelected(dayOfMonth)\"\n        [class.month__date--disabled]=\"isDisabled(dayOfMonth)\"\n        [attr.aria-disabled]=\"isDisabled(dayOfMonth)\"\n        [class.month__date--active]=\"isActive(dayOfMonth)\"\n        [class.month__date--highlighted]=\"isHighlighted(dayOfMonth) && !isSelected(dayOfMonth)\"\n        [tabIndex]=\"isActive(dayOfMonth) ? 0 : -1\"\n        [attr.aria-current]=\"!isCurrent(dayOfMonth) && 'date'\"\n        role=\"option\"\n        [attr.cdkFocusInitial]=\"isActive(dayOfMonth) ? '' : null\"\n  >\n    {{dayOfMonth | date:'d'}}\n  </time>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}:host-context(.calendar--disabled)>*{opacity:.38;cursor:initial}.month{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem}@media (min-width: 360px){.month{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.month{width:auto;margin:0;line-height:initial;justify-content:center}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-sunday time:first-child{margin-left:calc(0 * var(--calendar-cell-size--accessible));grid-column:1}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-sunday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-monday time:first-child{margin-left:calc(1 * var(--calendar-cell-size--accessible));grid-column:2}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-monday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-tuesday time:first-child{margin-left:calc(2 * var(--calendar-cell-size--accessible));grid-column:3}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-tuesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-wednesday time:first-child{margin-left:calc(3 * var(--calendar-cell-size--accessible));grid-column:4}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-wednesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-thursday time:first-child{margin-left:calc(4 * var(--calendar-cell-size--accessible));grid-column:5}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-thursday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-friday time:first-child{margin-left:calc(5 * var(--calendar-cell-size--accessible));grid-column:6}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-friday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-sunday) .month--first-day-saturday time:first-child{margin-left:calc(6 * var(--calendar-cell-size--accessible));grid-column:7}@supports (display: grid){:host-context(.calendar--first-day-of-week-sunday) .month--first-day-saturday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-monday time:first-child{margin-left:calc(0 * var(--calendar-cell-size--accessible));grid-column:1}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-monday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-tuesday time:first-child{margin-left:calc(1 * var(--calendar-cell-size--accessible));grid-column:2}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-tuesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-wednesday time:first-child{margin-left:calc(2 * var(--calendar-cell-size--accessible));grid-column:3}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-wednesday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-thursday time:first-child{margin-left:calc(3 * var(--calendar-cell-size--accessible));grid-column:4}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-thursday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-friday time:first-child{margin-left:calc(4 * var(--calendar-cell-size--accessible));grid-column:5}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-friday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-saturday time:first-child{margin-left:calc(5 * var(--calendar-cell-size--accessible));grid-column:6}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-saturday time:first-child{margin-left:0}}:host-context(.calendar--first-day-of-week-monday) .month--first-day-sunday time:first-child{margin-left:calc(6 * var(--calendar-cell-size--accessible));grid-column:7}@supports (display: grid){:host-context(.calendar--first-day-of-week-monday) .month--first-day-sunday time:first-child{margin-left:0}}.month__date{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;cursor:pointer}.month__date--active{background-color:rgba(var(--core-color-secondary-rgb),.4)}.month__date--selected{background-color:var(--core-color-primary)!important;color:var(--core-color-light)!important}.month__date--highlighted{background-color:rgba(var(--core-color-primary-rgb),.2);color:var(--core-color-primary)!important}.month__date--disabled{opacity:.38}:host-context(.calendar--disabled) .month__date{cursor:initial}.month .month__date{border-radius:50%;font-size:calc(var(--calendar-cell-size--accessible) / 2.5);font-weight:600;color:var(--core-color-dark);margin:calc(var(--calendar-cell-size--accessible) / 11.6);transition:background-color .3s cubic-bezier(.4,0,.2,1),color .3s cubic-bezier(.4,0,.2,1)}.month .month__date:hover{background-color:var(--core-light-gray)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { selectedDate: [{
                type: Input
            }], highlightedDate: [{
                type: Input
            }], min: [{
                type: Input
            }], locale: [{
                type: Input
            }], activeDate: [{
                type: Input
            }], month: [{
                type: Input
            }], selectedDateChange: [{
                type: Output
            }], activeDateChange: [{
                type: Output
            }] } });

class DaysOfWeekComponent {
    constructor(localeId) {
        this.localeId = localeId;
    }
    get locale() {
        return this._locale;
    }
    set locale(locale) {
        this._locale = locale || this.localeId;
        this.daysOfWeek = this.getDaysOfWeek();
        this.narrowDaysOfWeek = this.getNarrowDaysOfWeek();
    }
    ngOnInit() {
        if (!this.locale) {
            this.locale = this.localeId;
        }
    }
    getDaysOfWeek() {
        return getLocaleDayNames(this.locale, FormStyle.Format, TranslationWidth.Wide);
    }
    getNarrowDaysOfWeek() {
        return getLocaleDayNames(this.locale, FormStyle.Format, TranslationWidth.Narrow);
    }
}
DaysOfWeekComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: DaysOfWeekComponent, deps: [{ token: LOCALE_ID }], target: i0.ɵɵFactoryTarget.Component });
DaysOfWeekComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: DaysOfWeekComponent, selector: "lib-days-of-week", inputs: { locale: "locale" }, ngImport: i0, template: "<div class=\"days-of-week\">\n  <abbr class=\"days-of-week__day\"\n        *ngFor=\"let dayOfWeek of daysOfWeek; index as index\"\n        [title]=\"dayOfWeek\"\n        [attr.aria-label]=\"dayOfWeek\"\n  >{{daysOfWeek[index].charAt(0) + daysOfWeek[index].charAt(1)}}</abbr>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}:host-context(.calendar--disabled)>*{opacity:.38}.days-of-week{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem;position:sticky;top:0;z-index:1;color:var(--core-color-dark);font-weight:400;font-size:calc(var(--calendar-cell-size--accessible) / 2.5)}@media (min-width: 360px){.days-of-week{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.days-of-week{width:auto;margin:0;line-height:initial;justify-content:center}}:host-context(.calendar--first-day-of-week-monday) .days-of-week abbr:first-child{order:1}.days-of-week__day{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;font-variant:none;text-decoration:none}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: DaysOfWeekComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-days-of-week', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"days-of-week\">\n  <abbr class=\"days-of-week__day\"\n        *ngFor=\"let dayOfWeek of daysOfWeek; index as index\"\n        [title]=\"dayOfWeek\"\n        [attr.aria-label]=\"dayOfWeek\"\n  >{{daysOfWeek[index].charAt(0) + daysOfWeek[index].charAt(1)}}</abbr>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}:host-context(.calendar--disabled)>*{opacity:.38}.days-of-week{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem;position:sticky;top:0;z-index:1;color:var(--core-color-dark);font-weight:400;font-size:calc(var(--calendar-cell-size--accessible) / 2.5)}@media (min-width: 360px){.days-of-week{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.days-of-week{width:auto;margin:0;line-height:initial;justify-content:center}}:host-context(.calendar--first-day-of-week-monday) .days-of-week abbr:first-child{order:1}.days-of-week__day{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;font-variant:none;text-decoration:none}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [LOCALE_ID]
                    }] }];
    }, propDecorators: { locale: [{
                type: Input
            }] } });

class MonthAndYearPipe {
    constructor(localeId) {
        this.localeId = localeId;
        this.toLocaleStringSupportsLocales = toLocaleStringSupportsLocales();
    }
    transform(value, locale = this.localeId, format) {
        if (!isValidDate(value)) {
            return null;
        }
        return this.toLocaleStringSupportsLocales && !format
            ? value.toLocaleString(locale, monthAndYearFormatOptions)
            : formatDate(value, format || getFallbackLocaleMonthAndYearFormat(locale), locale);
    }
}
MonthAndYearPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthAndYearPipe, deps: [{ token: LOCALE_ID }], target: i0.ɵɵFactoryTarget.Pipe });
MonthAndYearPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: MonthAndYearPipe, name: "monthAndYear" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthAndYearPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monthAndYear'
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [LOCALE_ID]
                    }] }];
    } });

class MonthHeaderComponent {
    constructor() {
        this.month = startOfMonth(new Date());
        this.activeMonth = startOfMonth(new Date());
        this.showMonthStepper = true;
        this.activeMonthChange = new EventEmitter();
    }
    stepMonth(delta) {
        const activeMonth = addMonths(this.activeMonth || new Date(), delta);
        this.activeMonthChange.emit(activeMonth);
    }
}
MonthHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MonthHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: MonthHeaderComponent, selector: "lib-month-header", inputs: { month: "month", activeMonth: "activeMonth", showMonthStepper: "showMonthStepper", monthAndYearFormat: "monthAndYearFormat", locale: "locale" }, outputs: { activeMonthChange: "activeMonthChange" }, ngImport: i0, template: "<div class=\"month-header\">\n  <button class=\"month-header__stepper month-header__stepper--previous\"\n          *ngIf=\"showMonthStepper\"\n          (click)=\"stepMonth(-1)\"\n          type=\"button\"\n          aria-label=\"Previous month\"\n  >\u25C0</button>\n  <time class=\"month-header__caption\"\n        [dateTime]=\"month | date:'yyyy-MM'\"\n  >{{month | monthAndYear:locale:monthAndYearFormat}}</time>\n  <button class=\"month-header__stepper month-header__stepper--next\"\n          *ngIf=\"showMonthStepper\"\n          (click)=\"stepMonth(1)\"\n          type=\"button\"\n          aria-label=\"Next month\"\n  >\u25B6</button>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}.month-header{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem;font-weight:700;font-size:calc(var(--calendar-cell-size--accessible) / 2.25)}@media (min-width: 360px){.month-header{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.month-header{width:auto;margin:0;line-height:initial;justify-content:center}}.month-header__caption{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;flex-grow:1;grid-column:2/span 5}.month-header__stepper{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;padding:0;margin:0;border:0;background:none;cursor:pointer}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1.DatePipe, name: "date" }, { kind: "pipe", type: MonthAndYearPipe, name: "monthAndYear" }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: MonthHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-month-header', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"month-header\">\n  <button class=\"month-header__stepper month-header__stepper--previous\"\n          *ngIf=\"showMonthStepper\"\n          (click)=\"stepMonth(-1)\"\n          type=\"button\"\n          aria-label=\"Previous month\"\n  >\u25C0</button>\n  <time class=\"month-header__caption\"\n        [dateTime]=\"month | date:'yyyy-MM'\"\n  >{{month | monthAndYear:locale:monthAndYearFormat}}</time>\n  <button class=\"month-header__stepper month-header__stepper--next\"\n          *ngIf=\"showMonthStepper\"\n          (click)=\"stepMonth(1)\"\n          type=\"button\"\n          aria-label=\"Next month\"\n  >\u25B6</button>\n</div>\n", styles: [".month{--calendar-cell-size--accessible: 2.1875rem}.month-header{display:flex;flex-wrap:wrap;width:calc(7 * var(--calendar-cell-size--accessible));margin:0 auto;line-height:var(--calendar-cell-size--accessible);display:grid;grid-template-columns:repeat(7,2.625rem);grid-auto-rows:2.625rem;font-weight:700;font-size:calc(var(--calendar-cell-size--accessible) / 2.25)}@media (min-width: 360px){.month-header{grid-template-columns:repeat(7,2.1875rem);grid-auto-rows:var(--calendar-cell-size--accessible)}}@supports (display: grid){.month-header{width:auto;margin:0;line-height:initial;justify-content:center}}.month-header__caption{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;flex-grow:1;grid-column:2/span 5}.month-header__stepper{flex-basis:var(--calendar-cell-size--accessible);display:flex;justify-content:center;align-items:center;padding:0;margin:0;border:0;background:none;cursor:pointer}\n"] }]
        }], propDecorators: { month: [{
                type: Input
            }], activeMonth: [{
                type: Input
            }], showMonthStepper: [{
                type: Input
            }], monthAndYearFormat: [{
                type: Input
            }], locale: [{
                type: Input
            }], activeMonthChange: [{
                type: Output
            }] } });

let CustomControl$1 = class CustomControl {
};

class DatePicker extends CustomControl$1 {
    constructor(changeDetectorRef, localeId, elementRef) {
        super();
        this.changeDetectorRef = changeDetectorRef;
        this.localeId = localeId;
        this.elementRef = elementRef;
        this.touched = false;
        this.disabled = false;
        this.showMonthStepper = true;
        this.activeDate = startOfDay(new Date());
        this._numberOfMonths = 1;
        this.valueChange = new EventEmitter();
        this.trackByMilliseconds = (_, month) => {
            // avoid destroying month and month-header components in one-month view (with month steppers)
            // otherwise month stepper buttons would lose focus after press
            // also avoid destroying them when changing firstMonth in multi-month view
            return this.showMonthStepper || month.getTime();
        };
    }
    get locale() {
        return this._locale;
    }
    set locale(locale) {
        this._locale = locale || this.localeId;
    }
    get firstDayOfWeek() {
        return this._firstDayOfWeek || this.getDefaultFirstDayOfWeek();
    }
    set firstDayOfWeek(firstDayOfWeek) {
        this._firstDayOfWeek = firstDayOfWeek;
    }
    set firstMonth(firstMonth) {
        this._firstMonth = firstMonth;
        this.activeMonth = this._firstMonth || undefined;
    }
    get firstMonth() {
        return this._firstMonth;
    }
    set numberOfMonths(numberOfMonths) {
        this._numberOfMonths = coerceNumberProperty(numberOfMonths);
        this.showMonthStepper = this._numberOfMonths <= 2;
    }
    get numberOfMonths() {
        return this._numberOfMonths;
    }
    ngOnInit() {
        if (!this.locale) {
            this.locale = this.localeId;
        }
    }
    ngAfterContentInit() {
        // first lifecycle hook after attached FormControl calls writeValue() with the value passed to its constructor
        this.months = this.getMonths();
    }
    ngOnChanges(changes) {
        if ((changes.numberOfMonths && !changes.numberOfMonths.firstChange) || (changes.firstMonth && !changes.firstMonth.firstChange)) {
            this.months = this.getMonths();
        }
    }
    onActiveDateChange(activeDate) {
        this.activeDate = activeDate;
        if (!areDatesInSameMonth(this.activeDate, this.activeMonth || new Date())) {
            this.activeMonth = startOfMonth(this.activeDate);
            if (this.showMonthStepper) {
                this.months = this.getMonths();
            }
        }
        setTimeout(() => {
            this.elementRef.nativeElement.querySelector('[tabindex="0"]').focus();
        });
    }
    onActiveMonthChange(activeMonth) {
        this.activeMonth = activeMonth;
        this.activeDate = setDate(this.activeMonth, this.activeDate.getDate());
        this.months = this.getMonths();
    }
    onSelect(date) {
        if (!this.disabled) {
            this.value = date;
            this.activeMonth = date;
            this.activeDate = date;
            this.valueChange.emit(date);
            if (this.onChange) {
                this.onChange(date);
            }
            if (this.onTouched) {
                this.onTouched();
            }
        }
    }
    writeValue(value) {
        // TODO: what if calendar or the given date is disabled?
        this.value = isValidDate(value) ? startOfDay(value) : undefined;
        this.changeDetectorRef.markForCheck();
        if (this.showMonthStepper && this.value) {
            this.activeMonth = this.value;
            this.months = this.getMonths();
        }
    }
    registerOnChange(onChangeCallback) {
        this.onChange = onChangeCallback;
    }
    registerOnTouched(onTouchedCallback) {
        this.onTouched = () => {
            this.touched = true;
            onTouchedCallback();
        };
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
        this.changeDetectorRef.markForCheck();
    }
    getMonths() {
        const firstMonth = (this.showMonthStepper ? this.activeMonth : this.firstMonth) || new Date();
        const startOfFirstMonth = startOfMonth(firstMonth);
        return Array.from({ length: this.numberOfMonths }, (_, index) => addMonths(startOfFirstMonth, index));
    }
    getDefaultFirstDayOfWeek() {
        return WeekDay[getLocaleFirstDayOfWeek(this.locale)];
    }
}
DatePicker.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: DatePicker, deps: [{ token: i0.ChangeDetectorRef }, { token: LOCALE_ID }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
DatePicker.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: DatePicker, selector: "core-datepicker", inputs: { value: "value", highlightedDate: "highlightedDate", min: "min", monthAndYearFormat: "monthAndYearFormat", locale: "locale", firstDayOfWeek: "firstDayOfWeek", firstMonth: "firstMonth", numberOfMonths: "numberOfMonths" }, outputs: { valueChange: "valueChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => DatePicker),
            multi: true
        },
        {
            provide: CustomControl$1,
            useExisting: DatePicker
        }
    ], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div class=\"calendar\"\n     [ngClass]=\"'calendar--first-day-of-week-' + (firstDayOfWeek | lowercase)\"\n     [class.calendar--disabled]=\"disabled\"\n>\n  <ng-container *ngFor=\"let month of months; trackBy: trackByMilliseconds\">\n    <lib-month-header [month]=\"month\"\n                      [activeMonth]=\"activeMonth\"\n                      (activeMonthChange)=\"onActiveMonthChange($event)\"\n                      [monthAndYearFormat]=\"monthAndYearFormat\"\n                      [showMonthStepper]=\"showMonthStepper\"\n                      [locale]=\"locale\"\n    ></lib-month-header>\n    <lib-days-of-week [locale]=\"locale\"></lib-days-of-week>\n    <lib-month [month]=\"month\"\n               [selectedDate]=\"value\"\n               (selectedDateChange)=\"onSelect($event)\"\n               [min]=\"min\"\n               [activeDate]=\"activeDate\"\n               [highlightedDate]=\"highlightedDate\"\n               (activeDateChange)=\"onActiveDateChange($event)\"\n               [locale]=\"locale\"\n    ></lib-month>\n  </ng-container>\n</div>\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: MonthComponent, selector: "lib-month", inputs: ["selectedDate", "highlightedDate", "min", "locale", "activeDate", "month"], outputs: ["selectedDateChange", "activeDateChange"] }, { kind: "component", type: DaysOfWeekComponent, selector: "lib-days-of-week", inputs: ["locale"] }, { kind: "component", type: MonthHeaderComponent, selector: "lib-month-header", inputs: ["month", "activeMonth", "showMonthStepper", "monthAndYearFormat", "locale"], outputs: ["activeMonthChange"] }, { kind: "pipe", type: i1.LowerCasePipe, name: "lowercase" }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: DatePicker, decorators: [{
            type: Component,
            args: [{ selector: 'core-datepicker', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => DatePicker),
                            multi: true
                        },
                        {
                            provide: CustomControl$1,
                            useExisting: DatePicker
                        }
                    ], template: "<div class=\"calendar\"\n     [ngClass]=\"'calendar--first-day-of-week-' + (firstDayOfWeek | lowercase)\"\n     [class.calendar--disabled]=\"disabled\"\n>\n  <ng-container *ngFor=\"let month of months; trackBy: trackByMilliseconds\">\n    <lib-month-header [month]=\"month\"\n                      [activeMonth]=\"activeMonth\"\n                      (activeMonthChange)=\"onActiveMonthChange($event)\"\n                      [monthAndYearFormat]=\"monthAndYearFormat\"\n                      [showMonthStepper]=\"showMonthStepper\"\n                      [locale]=\"locale\"\n    ></lib-month-header>\n    <lib-days-of-week [locale]=\"locale\"></lib-days-of-week>\n    <lib-month [month]=\"month\"\n               [selectedDate]=\"value\"\n               (selectedDateChange)=\"onSelect($event)\"\n               [min]=\"min\"\n               [activeDate]=\"activeDate\"\n               [highlightedDate]=\"highlightedDate\"\n               (activeDateChange)=\"onActiveDateChange($event)\"\n               [locale]=\"locale\"\n    ></lib-month>\n  </ng-container>\n</div>\n" }]
        }], ctorParameters: function () {
        return [{ type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [LOCALE_ID]
                    }] }, { type: i0.ElementRef }];
    }, propDecorators: { value: [{
                type: Input
            }], highlightedDate: [{
                type: Input
            }], min: [{
                type: Input
            }], monthAndYearFormat: [{
                type: Input
            }], locale: [{
                type: Input
            }], firstDayOfWeek: [{
                type: Input
            }], firstMonth: [{
                type: Input
            }], numberOfMonths: [{
                type: Input
            }], valueChange: [{
                type: Output
            }] } });

class CoreDatePickerModule {
}
CoreDatePickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreDatePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreDatePickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreDatePickerModule, declarations: [DatePicker,
        MonthComponent,
        DaysOfWeekComponent,
        MonthHeaderComponent,
        MonthAndYearPipe], imports: [CommonModule], exports: [DatePicker] });
CoreDatePickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreDatePickerModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreDatePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DatePicker,
                        MonthComponent,
                        DaysOfWeekComponent,
                        MonthHeaderComponent,
                        MonthAndYearPipe,
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [DatePicker]
                }]
        }] });

/**
 * @license
 * Copyright 2022 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2022 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

class CustomControl {
}

var _ModalInPlace_overlayOrigin;
class ModalInPlace {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.isOverlayOpen = false;
        this.closeOnValueChange = true;
        // TODO: allow overlay origin to be undefined
        _ModalInPlace_overlayOrigin.set(this, void 0);
    }
    set overlayOrigin(overlayOrigin) {
        __classPrivateFieldSet(this, _ModalInPlace_overlayOrigin, overlayOrigin, "f");
        this.changeDetectorRef.markForCheck();
    }
    get overlayOrigin() {
        return __classPrivateFieldGet(this, _ModalInPlace_overlayOrigin, "f");
    }
    ngAfterContentInit() {
        this.controlList.changes.pipe(startWith(this.controlList), mergeMap(controlList => merge(...controlList.map((control) => control.valueChange))), filter(() => this.closeOnValueChange)).subscribe(() => {
            this.isOverlayOpen = false;
            this.changeDetectorRef.markForCheck();
        });
    }
    toggleOverlay() {
        this.isOverlayOpen = !this.isOverlayOpen;
        this.changeDetectorRef.markForCheck();
    }
}
_ModalInPlace_overlayOrigin = new WeakMap();
ModalInPlace.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ModalInPlace, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
ModalInPlace.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.1", type: ModalInPlace, selector: "core-modal-in-place", inputs: { isOverlayOpen: "isOverlayOpen", closeOnValueChange: "closeOnValueChange" }, queries: [{ propertyName: "controlList", predicate: CustomControl }], ngImport: i0, template: "<ng-template cdkConnectedOverlay\n             cdkConnectedOverlayHasBackdrop=\"true\"\n             [cdkConnectedOverlayOrigin]=\"overlayOrigin\"\n             [cdkConnectedOverlayOpen]=\"isOverlayOpen\"\n             cdkConnectedOverlayPanelClass=\"overlay__panel\"\n             cdkConnectedOverlayBackdropClass=\"overlay__backdrop\"\n             (backdropClick)=\"toggleOverlay()\"\n>\n  <div [cdkTrapFocus]=\"isOverlayOpen\"\n       [cdkTrapFocusAutoCapture]=\"isOverlayOpen\">\n    <ng-content></ng-content>\n  </div>\n</ng-template>\n", dependencies: [{ kind: "directive", type: i1$1.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i2.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ModalInPlace, decorators: [{
            type: Component,
            args: [{ selector: 'core-modal-in-place', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-template cdkConnectedOverlay\n             cdkConnectedOverlayHasBackdrop=\"true\"\n             [cdkConnectedOverlayOrigin]=\"overlayOrigin\"\n             [cdkConnectedOverlayOpen]=\"isOverlayOpen\"\n             cdkConnectedOverlayPanelClass=\"overlay__panel\"\n             cdkConnectedOverlayBackdropClass=\"overlay__backdrop\"\n             (backdropClick)=\"toggleOverlay()\"\n>\n  <div [cdkTrapFocus]=\"isOverlayOpen\"\n       [cdkTrapFocusAutoCapture]=\"isOverlayOpen\">\n    <ng-content></ng-content>\n  </div>\n</ng-template>\n" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { isOverlayOpen: [{
                type: Input
            }], closeOnValueChange: [{
                type: Input
            }], controlList: [{
                type: ContentChildren,
                args: [CustomControl]
            }] } });

class ModalToggleDirective extends CdkOverlayOrigin {
    constructor(elementRef) {
        super(elementRef);
    }
    ngAfterViewInit() {
        this.modal.overlayOrigin = this;
    }
    toggleOverLay() {
        this.modal.toggleOverlay();
    }
}
ModalToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ModalToggleDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ModalToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.1", type: ModalToggleDirective, selector: "[coreModalInPlaceToggle]", inputs: { modal: "modal" }, host: { listeners: { "click": "toggleOverLay()" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: ModalToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[coreModalInPlaceToggle]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { modal: [{
                type: Input
            }], toggleOverLay: [{
                type: HostListener,
                args: ['click']
            }] } });

class CoreModalInPlaceModule {
}
CoreModalInPlaceModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalInPlaceModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CoreModalInPlaceModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.1", ngImport: i0, type: CoreModalInPlaceModule, declarations: [ModalInPlace, ModalToggleDirective], imports: [OverlayModule,
        A11yModule], exports: [ModalInPlace, ModalToggleDirective] });
CoreModalInPlaceModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalInPlaceModule, imports: [OverlayModule,
        A11yModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.1", ngImport: i0, type: CoreModalInPlaceModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ModalInPlace, ModalToggleDirective],
                    imports: [
                        OverlayModule,
                        A11yModule
                    ],
                    exports: [ModalInPlace, ModalToggleDirective]
                }]
        }] });

/**
 * @license
 * Copyright 2022 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2022 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * @license
 * Copyright 2020 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ButtonDirective, CORE_CHECKBOX_CONTROL_VALUE_ACCESSOR, ClickOutsideDirective, CoreButtonModule, CoreCard, CoreCardModule, CoreCheckbox, CoreCheckboxChange, CoreCheckboxModule, CoreClickOutsideModule, CoreDatePickerModule, CoreHStack, CoreInput, CoreInputModule, CoreLabel, CoreModal, CoreModalInPlaceModule, CoreModalModule, CorePressableModule, CoreProgressBar, CoreProgressBarModule, CoreSelect, CoreSelectLabel, CoreSelectModule, CoreStackModule, CoreVStack, DatePicker, ModalInPlace, ModalToggleDirective, PressableDirective, ScrollLockService, SimpleCoreUIModule, avoidLast };
//# sourceMappingURL=simplecore-ui.mjs.map
