/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
/**
 * @license
 * Copyright 2020 willmcpo, MIT.
 *
 * Source code adapted from https://github.com/willmcpo/body-scroll-lock/blob/fe6bfea3a134f337e77e62ae380cdf29eac7216b/lib/bodyScrollLock.es6.js.
 * Originally published under an MIT license. Adapted by January 17, 2021.
 * Reason: To ensure that this code works with Angular Server Side rendering, additional checks were added when porting this code as an Angular Service.
 */
import { OnInit } from "@angular/core";
import * as i0 from "@angular/core";
export declare class ScrollLockService implements OnInit {
    private readonly platformId;
    private hasPassiveEvents;
    private get passiveTestOptions();
    constructor(platformId: any);
    ngOnInit(): void;
    private isIosDevice;
    private locks;
    private documentListenerAdded;
    private initialClientY;
    private previousBodyOverflowSetting;
    private previousBodyPaddingRight;
    allowTouchMove: (el: any) => boolean;
    private preventDefault;
    private setOverflowHidden;
    private restoreOverflowSetting;
    private isTargetElementTotallyScrolled;
    private handleScroll;
    disableBodyScroll: (targetElement: any, options?: any) => void;
    clearAllBodyScrollLocks: () => void;
    enableBodyScroll: (targetElement: any) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ScrollLockService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ScrollLockService>;
}
