import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { WeekDay } from '@angular/common';
import { ControlValueAccessor } from '@angular/forms';
import { CustomControl } from "./custom-control";
import * as i0 from "@angular/core";
export declare class DatePicker extends CustomControl<Date> implements AfterContentInit, ControlValueAccessor, OnChanges, OnInit {
    changeDetectorRef: ChangeDetectorRef;
    private localeId;
    private elementRef;
    months: readonly Date[];
    touched: boolean;
    disabled: boolean;
    showMonthStepper: boolean;
    activeDate: Date;
    activeMonth?: Date;
    private onChange?;
    private onTouched?;
    value?: Date;
    highlightedDate?: Date;
    min?: Date | null;
    monthAndYearFormat?: string;
    private _locale?;
    get locale(): string | undefined;
    set locale(locale: string | undefined);
    private _firstDayOfWeek?;
    get firstDayOfWeek(): keyof typeof WeekDay;
    set firstDayOfWeek(firstDayOfWeek: keyof typeof WeekDay);
    private _firstMonth?;
    set firstMonth(firstMonth: Date | undefined | null);
    get firstMonth(): Date | undefined | null;
    private _numberOfMonths;
    set numberOfMonths(numberOfMonths: any);
    get numberOfMonths(): any;
    valueChange: EventEmitter<Date>;
    trackByMilliseconds: (_: number, month: Date) => number | true;
    constructor(changeDetectorRef: ChangeDetectorRef, localeId: string, elementRef: ElementRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onActiveDateChange(activeDate: Date): void;
    onActiveMonthChange(activeMonth: Date): void;
    onSelect(date: Date): void;
    writeValue(value: Date): void;
    registerOnChange(onChangeCallback: (updatedValue: Date) => void): void;
    registerOnTouched(onTouchedCallback: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    private getMonths;
    private getDefaultFirstDayOfWeek;
    static ɵfac: i0.ɵɵFactoryDeclaration<DatePicker, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DatePicker, "core-datepicker", never, { "value": "value"; "highlightedDate": "highlightedDate"; "min": "min"; "monthAndYearFormat": "monthAndYearFormat"; "locale": "locale"; "firstDayOfWeek": "firstDayOfWeek"; "firstMonth": "firstMonth"; "numberOfMonths": "numberOfMonths"; }, { "valueChange": "valueChange"; }, never, never, false, never>;
}
