import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { DayStepDelta } from './day-step-delta.model';
import * as i0 from "@angular/core";
export declare const keyCodesToDaySteps: Map<number, DayStepDelta>;
export declare class MonthComponent implements AfterViewInit, OnChanges {
    changeDetectorRef: ChangeDetectorRef;
    daysOfMonth: readonly Date[];
    firstDayOfMonth: string;
    currentDate: Date;
    private readonly dateSelector;
    selectedDate?: Date;
    highlightedDate?: Date;
    min?: Date | null;
    locale?: string;
    activeDate: Date;
    private _month;
    get month(): Date;
    set month(month: Date);
    selectedDateChange: EventEmitter<Date>;
    activeDateChange: EventEmitter<Date>;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    isHighlighted(dayOfMonth: Date): boolean;
    isSelected(dayOfMonth: Date): boolean;
    isDisabled(dayOfMonth: Date): boolean;
    isActive(dayOfMonth: Date): boolean;
    isCurrent(dayOfMonth: Date): boolean;
    onKeydown(event: KeyboardEvent): void;
    onMonthClick(event: MouseEvent | Event): void;
    private onDateClick;
    private selectDate;
    private isTimeElement;
    static ɵfac: i0.ɵɵFactoryDeclaration<MonthComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MonthComponent, "lib-month", never, { "selectedDate": "selectedDate"; "highlightedDate": "highlightedDate"; "min": "min"; "locale": "locale"; "activeDate": "activeDate"; "month": "month"; }, { "selectedDateChange": "selectedDateChange"; "activeDateChange": "activeDateChange"; }, never, never, false, never>;
}
