/**
 * @license
 * Copyright 2021 SimpleCore All Rights Reserved.
 *
 * Use of this source code is governed private licensing for
 * internal SimpleCore projects
 */
import { AfterViewInit, ElementRef, EventEmitter, OnDestroy, Renderer2 } from '@angular/core';
import { ScrollLockService } from "../_services/scroll-lock.service";
import * as i0 from "@angular/core";
export declare class CoreModal implements AfterViewInit, OnDestroy {
    private renderer;
    private readonly platformId;
    private scrollLockService;
    get open(): boolean;
    set open(val: boolean);
    private _open;
    private isOpening;
    action: boolean;
    title: boolean;
    actionPrimary: boolean;
    actionSecondary: boolean;
    primaryButtonPressed: EventEmitter<any>;
    secondaryButtonPressed: EventEmitter<any>;
    modalElement: ElementRef | undefined;
    private viewInitialized;
    constructor(renderer: Renderer2, platformId: any, scrollLockService: ScrollLockService);
    ngAfterViewInit(): void;
    toggleModal(on: boolean): void;
    private openModal;
    private closeModal;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CoreModal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CoreModal, "core-modal", ["coreModal"], { "action": "action"; "title": "title"; "actionPrimary": "actionPrimary"; "actionSecondary": "actionSecondary"; }, { "primaryButtonPressed": "primaryButtonPressed"; "secondaryButtonPressed": "secondaryButtonPressed"; }, never, ["span[coreModalTitle]", "*", "span[coreModalActionPrimary]", "span[coreModalActionSecondary]"], false, never>;
}
